{ ------- Axes.pas ------- }

procedure TGraphe.DrawAxis;
var xAxeY,yAxeX : integer;
    xNombreMax,signeMargeX : integer;
    PointCourant : single;
                      
procedure TitreAxeX;
var xTitre,yTitre : integer;
    prompt : string;
begin
        yTitre := limiteCourbe.bottom+marge;
        with mondeX do if unite=''
             then prompt := nom
             else prompt := nom+'('+unite+')';
        xTitre := LimiteFenetre.right-canvas.textWidth(prompt);
        canvas.TextOut(xTitre,yTitre,prompt);
    	xNombreMax := limiteFenetre.right-largCarac*longNombreAxe div 2;
        if xtitre<xNombreMax then xNombreMax := xTitre;
end;

procedure TitreAxeY;
var prompt : string;
begin
      with mondeY do if unite<>''
          then prompt := nom+'('+unite+')'
          else prompt := nom;
      canvas.textOut(limiteFenetre.left+marge,limiteFenetre.Top,prompt);
end;

Function YcorrectNombre(y : integer) : boolean;
var limiteTop : integer;
begin with mondeY do begin
     LimiteTop := limiteCourbe.Top+marge;
     YcorrectNombre := ( y>(LimiteTop)) and
                       ( y<(limiteCourbe.Bottom-marge)) and
		       ( abs(y-yAxeX)>marge )
end end;

Function YcorrectGrad(y : integer) : boolean;
begin with mondeY do
     YcorrectGrad := ( y>limiteCourbe.Top) and
                     ( y<limiteCourbe.Bottom)
end;

Function XcorrectNombre(x : integer) : boolean;
begin
     XcorrectNombre := ( x>(limiteCourbe.left+marge)) and
                       ( x<xNombreMax) and
                       ( abs(x-xAxeY)>marge )
end;

Function XcorrectGrad(x : integer) : boolean;
begin
     XcorrectGrad := ( x>limiteCourbe.left) and
                     ( x<limiteCourbe.right)
end;

procedure OutTextY(y : integer;S : string);
begin
   canvas.TextOut(limiteFenetre.left+marge,y-hautCarac div 2,S)
end;

procedure OutTextX(x : integer;S : string);
begin
   canvas.TextOut(x,yAxeX+marge,S)
end;

procedure MyLine(x1,y1,x2,y2 : integer);
begin
     canvas.moveTo(x1,y1);
     canvas.lineTo(x2,y2);
end;

Procedure graduationX(x : integer;quadrillage : boolean);
begin
  if quadrillage
       then MyLine(x,limiteCourbe.top,x,limiteCourbe.bottom)
       else MyLine(x,yAxeX,x,yAxeX+marge);
end;

Procedure graduationY(y : integer;quadrillage : boolean);
begin
   if quadrillage
	 then MyLine(limiteCourbe.left,y,limiteCourbe.right,y)
	 else MyLine(xAxeY,y,xAxeY-signeMargeX*marge,y);
end;

  procedure initAxeX;
  var x1,y1 : integer;
  begin	 with mondeX,canvas do begin
	 PointCourant := PointDebut;
	 WindowXY(0,0,x1,y1);
	     if (x1>limiteCourbe.left) and (x1<limiteCourbe.right) then begin
		 pen.style := psDot;
		 Myline(x1,limiteCourbe.bottom,x1,limiteCourbe.top);
                 pen.style := psSolid;
	     end;
          TitreAxeX;
	  MyLine(limiteFenetre.left,yAxeX,limiteCourbe.right,yAxeX);
                    { flches }
          MyLine(LimiteCourbe.right-marge*3,yAxeX+marge,LimiteCourbe.right,yAxeX);
          MyLine(LimiteCourbe.right-marge*3,yAxeX-marge,LimiteCourbe.right,yAxeX);
  end end;{initAxeX}

  procedure traceAxeX;
  var xs,ys : integer;
      NombreAff : strCourte;
  begin with mondeX do begin
       initAxeX;
       if Quadrillage then canvas.pen.style := psDot;
       repeat
          windowXY(PointCourant,mondeY.Mini,xs,ys);
      	  if XcorrectGrad(xs) then begin
               graduationX(xs,Quadrillage);
               if XcorrectNombre(xs) then begin
        	  if abs(PointCourant)< (Maxi-Mini)/100 then pointCourant := 0;
                  NombreAff := formatAxe(pointCourant);
        	  OutTextX(xs,NombreAff);
      	       end;
          end;
      	  PointCourant := PointCourant+deltaAxe;
      until ( PointCourant>=Maxi );
      canvas.pen.style := psSolid;
 end end;{traceAxeX}

 procedure initAxeY;
 var x1,y1 : integer;
 begin	with mondeY do begin
	PointCourant := PointDebut;
        WindowXY(0,0,x1,y1);
        if (y1>limiteCourbe.Top) and (y1<limiteCourbe.Bottom)then begin
            canvas.pen.style := psDot;
	    Myline(limiteCourbe.left,y1,limiteCourbe.right,y1);
            canvas.pen.style := psSolid;
        end;
        MyLine(xAxeY,yAxeX,xAxeY,limiteCourbe.Top);
              { flches }
        MyLine(xAxeY-marge,LimiteCourbe.Top+2*marge,xAxeY,LimiteCourbe.Top-marge);
        MyLine(xAxeY+marge,LimiteCourbe.Top+2*marge,xAxeY,LimiteCourbe.Top-marge);
        TitreAxeY;
 end end;{initAxeY}

 procedure traceAxeY;
 var xs,ys : integer;
     nombreAff : strCourte;
 begin with mondeY do begin
      initAxeY;
      if Quadrillage then canvas.pen.style := psDot;
      repeat
           windowXY(mondeX.Mini,PointCourant,xs,ys);
	   {coordonne cran de marque}
	   if YcorrectGrad(ys) then begin
	   	 graduationY(ys,quadrillage);
         	 if YcorrectNombre(ys) then begin
	   	    if abs(pointCourant) < (Maxi-Mini)/1000 then pointCourant := 0;
                    NombreAff := formatAxe(pointCourant);
	   	    OutTextY(ys,NombreAff);
                 end;
	   end;
	   pointCourant := pointCourant+deltaAxe;
      until ( pointCourant>=Maxi );
      canvas.pen.style := psSolid;
 end end;{traceAxeY}

procedure zeroX;
var x1,y1 : integer;
begin with mondeX do
	  WindowXY(0,0,x1,y1);
	  if (x1>limiteCourbe.left) and (x1<limiteCourbe.right) then
	      Myline(x1,limiteCourbe.bottom,x1,limiteCourbe.top);
end;{zeroX}

 procedure zeroY;
 var x1,y1 : integer;
 begin
     with mondeY do begin
	windowXY(0,0,x1,y1);
	if (y1>limiteCourbe.Top) and  (y1<limiteCourbe.Bottom) then
	   Myline(limiteCourbe.left,y1,limiteCourbe.right,y1);
     end
end;{zeroY}

begin{ DrawAxis } with canvas do begin
     signeMargeX := -1;
     pen.style := psSolid;
     pen.color := couleurAxe;
     font.color := CouleurAxe;
     yAxeX := limiteCourbe.bottom;
     xAxeY := limiteCourbe.left;
     if mondeX.avecAxe
        then traceAxeX
        else zeroX;
     if mondeY.avecAxe
        then traceAxeY
        else zeroY;
end end;{ DrawAxis }




