unit jmmutil;

interface

uses
   SysUtils, Windows, Messages, Classes, Dialogs, Forms,
   StdCtrls, Consts, Controls, shlObj, graphics,
   oomisc, awuser, AwWin32, math;

resourcestring
   stBlanc = 'Blanc en cours...';
   stBadBlanc = 'Blanc  faire ?';
   stAcqSpectre = 'Acquisition du spectre...';
   stLectureSpectre = 'Lecture du spectre...';
   stLectureAbs = 'Attente de l''absorbance...';
   stBadNombre = 'Nombre mal crit';
   stBadData = 'Donnes incorrectes';
   stBadAbs = 'Absorbance lue incorrecte';
   stAbs = 'Absorbance';
   stSauve = 'Sauvegarde ?';
   stDeconnect = 'Dconnect.';
   stConnect =   'Connect.';
   stDeconnection = 'Dconnection';
   stConnection =   'Connection';
   stTouches = 'Ractivation des touches du spectro';
   stRemote = 'L''ordinateur prend le controle du spectro';
   stRechercheCOM = 'Recherche en cours sur COM';
   stValiderAbs = '. Valider pour lire l''absorbance';
   hAbsInconnue = 'Cliquer pour dterminer une concentration inconnue';
   stDeltat = 'Dt=';
   stPrecisionAbs = 'Prcision de l''ajustement sur A : ';
   hDelCalc = 'Suppression du point calcul actif';
   hDelClavier = 'Suppression du point entr au clavier actif';
   stTaper = 'Taper la valeur de ';
   stRecherche = 'Recherche en cours ...';
   stRecommencer = 'Recommencer la recherche';
   stNoSpectro = 'Spectrophotomtre Biochrom non dtect';

   aideBlanc = 'Faire d''abord le blanc : installer la cuve avec solvant dans le spectro puis cliquer sur le bouton "Blanc"';
   aideSpectre = 'Insrez l''chantillon et cliquez sur le bouton "Spectre"';
   stAcquis = ' acquis  ';

   stTemps = 'temps';
   stLambda = 'Longueur d''onde';
   stArret = 'arrt de l''acquisition en cours';
   stConfirm = '    Vous confirmez ?';
   stConcentration =  'concentration';
   erWriteFile = 'Erreur d''criture du fichier';

const
   MaxVecteur = 1500;
   MaxPages = 32;
   SansSignif: double = 1e-26;

   PrecisionMax    = 7;
   PrecisionMin    = 3;
   SymbReg: char   = '';
   SymbReg2: char  = '&';

   lambdaR = #136;

        crSupprArr = char(vk_back);
        crSuppr = char(vk_clear);
        crHaut = char(vk_up);
        crBas = char(vk_down);
        crGauche = char(vk_left);
        crDroite = char(vk_right);
        crHome = char(vk_home);
        crEnd = char(vk_end);
        crTabulation = char(vk_tab);
        crTab  = #9;
        crLF = #10; // $0A
        crESC = #27; // $1B
        crCR  = #13; // $0D

type
   IndiceVecteur = 0..MaxVecteur;
   IndicePage = 0..MaxPages;   
   Vecteur = array[IndiceVecteur] of double;
   Matrice = array[IndicePage] of vecteur;
   ChaineAzt = array[0..255] of char;

   TcharSet = set of char;
   strCourte = string[20];
   CoefUnite = (zero, yocto, zepto, atto, femto, pico, nano, micro, milli,
      nulle, kilo, mega, giga, tera, peta, exa, zetta, yotta, infini);

const
   ToucheEdition : TcharSet = [crSupprArr,crGauche,crDroite,crHome,crEnd,crSuppr];
   Chiffre: TcharSet = ['0'..'9'];
   ChiffreEtc: TcharSet = ['0'..'9', '+', '-', 'e', 'E', '.'];
   ChiffreWin: TcharSet = ['0'..'9', '+', '-', 'e', 'E', '.', ','];
   crAck      = #6;
   crBEL      = #7;
   crETX      = #3;
   crNoAck    = #21; // $15
   separateur: TCharSet = [' ', crTab, ','];
   caracPrefixe: TcharSet =
      ['y', 'z', 'a', 'f', 'p', 'n', '', 'm', 'k', 'M', 'G', 'T', 'P', 'E'];
   captionSauve : array[0..2] of string[16] =
         ('Regressi','Copier','Sauver');

function FormatLong(nombre: double): strCourte;
function FormatCourt(nombre: double): strCourte;
function FormatPrec(nombre: double): strCourte;
function FloatToStrPoint(valeur: double): strCourte;
function FloatToStrWin(valeur: double): strCourte;
function StrToFloatWin(nombre: strCourte): double;
function StrToFloatPoint(nombre: strCourte): double;
function EncodeDuree(duree: longint): TdateTime;
function DureeSec(Instant: TdateTime): integer;
procedure afficheErreur(texte: shortString);
function OKreg(const strErreur : shortString) : boolean;
Function HexaStrToInt(chaine : strCourte) : integer;
Function WavelengthToColor(CONST Wavelength:  integer) : Tcolor;

procedure GetMinMax(const V: vecteur; N: indiceVecteur; var mini, maxi: double);
procedure VerifMinMaxReal(var mini, maxi: double);

function IsPortAvailable(ComNum: cardinal): boolean;

var
   mesDocsDir, appData : string;

implementation


const
   prefixeUnite: array[coefunite] of char =
      ('0', 'y', 'z', 'a', 'f', 'p', 'n', '', 'm',
      ' ', 'k', 'M', 'G', 'T', 'P', 'E', 'Z', 'Y', '');

   expUnite: array[coefUnite] of string[4] =
      ('E-27', 'E-24', 'E-21', 'E-18', 'E-15', 'E-12', 'E-9', 'E-6', 'E-3',
      '', 'E+3', 'E+6', 'E+9', 'E+12', 'E+15', 'E+18', 'E+21', 'E+24', 'E+27');
      

function FloatToStrPoint(valeur: double): strCourte;
var
   nombre: strCourte;
   posSeparator: integer;
begin
   nombre := FloatToStrF(valeur, ffGeneral, 7, 4);
   if decimalSeparator<>'.' then begin
      posSeparator := pos(decimalSeparator, nombre);
      if posSeparator > 0 then
         Nombre[posSeparator] := '.';
   end;
   result := nombre;
end;

function FloatToStrWin(valeur: double): strCourte;
begin
   result := FloatToStrF(valeur, ffGeneral, 7, 4);
   if pos(decimalSeparator,result)=0 then
      result := result+decimalSeparator+'0';
end;

procedure ConvertitPrefixe(var nombre: strCourte);
var
   u: coefUnite;
   c: char;
begin
   c := nombre[length(nombre)];
   if c in caracPrefixe then begin
      u := zero;
      repeat
         Inc(u)
      until (c = prefixeUnite[u]);
      Delete(nombre, length(nombre), 1);
      nombre := nombre + expUnite[u];
   end;
end;

function StrToFloatPoint(nombre: strCourte): double;
var
   posSeparator: integer;
begin
   if decimalSeparator<>'.' then begin
      posSeparator := pos('.', nombre);
      if posSeparator > 0 then
         Nombre[posSeparator] := decimalSeparator;
   end;
   try
      result := strToFloat(nombre);
   except
      result := sansSignif;
   end;
end;

function StrToFloatWin(nombre: strCourte): double;
var
   posSeparator: integer;
begin
   if decimalSeparator<>',' then begin
      posSeparator := pos(',', nombre);
      if posSeparator > 0 then
         Nombre[posSeparator] := decimalSeparator;
   end
   else if decimalSeparator<>'.' then begin
      posSeparator := pos('.', nombre);
      if posSeparator > 0 then
         Nombre[posSeparator] := decimalSeparator;
   end;
   ConvertitPrefixe(nombre);
   try
      result := strToFloat(nombre);
   except
      result := sansSignif;
   end;
end;

function FormatCourt(Nombre: double): strCourte;
begin
   FormatCourt := FloatToStrF(nombre, ffGeneral, PrecisionMin, 0);
end;

function FormatPrec(Nombre: double): strCourte;
var p : integer;
begin
    result := FormatCourt(nombre);
    p := 0;
    repeat inc(p)
    until (p=length(result)) or not (result[p] in ['0','.',',']);
    if p=length(result) then exit;
    if result[p]>'1'
       then result := copy(result,1,p)
       else result := copy(result,1,p+1)
end;

function FormatLong(Nombre: double): strCourte;
begin
   FormatLong := FloatToStrF(nombre, ffGeneral, PrecisionMax, 0);
end;

function EncodeDuree(duree: longint): TdateTime;
var
   h, m, s, ms: word;
begin
   h  := duree div 3600;
   duree := duree - h * 3600;
   m  := duree div 60;
   duree := duree - m * 60;
   s  := duree;
   ms := 0;
   EncodeDuree := EncodeTime(h, m, s, ms);
end;

function DureeSec(Instant: TdateTime): integer;
var
   h, m, s, ms: word;
begin
   decodeTime(instant, h, m, s, ms);
   result := h * 3600 + m * 60 + s; //  + ms/1000;
end;

procedure afficheErreur(texte: shortString);
var
   SauveCursor: Tcursor;
begin
   SauveCursor := Screen.cursor;
   Screen.cursor := crDefault;
   MessageDlg(texte, mtError, [mbOK], 0);
   Screen.cursor := SauveCursor;
end;

procedure GetMinMax(const V: vecteur; N: indiceVecteur; var mini, maxi: double);
var
   i: integer;
begin
   Mini := V[0];
   Maxi := V[0];
   for i := 1 to pred(N) do
      if V[i] > Maxi then
         Maxi := V[i]
      else if V[i] < Mini then
         Mini := V[i];
end;

procedure VerifMinMaxReal(var mini, maxi: double);
var
   z: double;
begin
   if Maxi < Mini then begin
      z := Maxi;
      Maxi := Mini;
      Mini := z;
   end;
end;

function AddBackSlash(aPath: string): string;
begin
   Result := EmptyStr;
   if (aPath <> '') and (aPath[Length(aPath)] <> '\') then
      Result := aPath + '\';
end;

// permet de retrouver un repertoire d'aprs sa valeur CSIDL
function GetFolder(CSIDLValue: integer): string;
var
   IdList: PITEMIDLIST;
   Folder: array[0..MAX_PATH] of char;
begin
   if not Failed(SHGetSpecialFolderLocation(0, CSIDLValue, IdList)) then
   begin
      SHGetPathFromIDList(IdList, Folder);
      Result := AddBackSlash(Folder);
   end;
end;

function IsPortAvailable(ComNum: cardinal): boolean;

   function MakeComName(const Dest: PChar; const ComNum: cardinal): PChar;
      // -Return a string like 'COMXX'
   begin
      StrFmt(Dest, '\\.\COM%d', [ComNum]);
      MakeComName := Dest;
   end;

var
   ComName: array[0..16] of char;
   Res: integer;
   DeviceLayer: TApdBaseDispatcher;
begin
   DeviceLayer := TApdWin32Dispatcher.Create(nil);
   try
      Res := DeviceLayer.OpenCom(MakeComName(ComName, ComNum), 64, 64);
      Result := (Res < 0) and (GetLastError <> DWORD(Abs(ecAccessDenied)));
      result := not result;
      if result then DeviceLayer.CloseCom;
   finally
      DeviceLayer.Free;
   end;
end;

Function HexaStrToInt(chaine : strCourte) : integer;
begin
      result := strToIntDef('$'+chaine,0);
end;

function OKreg(const strErreur : shortString) : boolean;
var  SauveCursor : Tcursor;
begin
     SauveCursor := Screen.cursor;
     Screen.cursor := crDefault;
     result := MessageDlg(strErreur,mtConfirmation,mbYesNo,0)=mrYes;
     Screen.cursor := SauveCursor;
end;

Function WavelengthToColor(CONST Wavelength:  integer) : Tcolor;
  CONST
    Gamma     =  0.80;
    IntensityMax = 255;
  VAR
    Blue   :  DOUBLE;
    factor :  DOUBLE;
    Green  :  DOUBLE;
    Red    :  DOUBLE;
    R,G,B:  BYTE;

  FUNCTION Adjust(CONST Color, Factor:  DOUBLE):  INTEGER;
  BEGIN
    IF Color = 0.0
      THEN RESULT := 0     // Don't want 0^x = 1 for x <> 0
      ELSE RESULT := ROUND(IntensityMax * Power(Color * Factor, Gamma))
  END;

BEGIN
  CASE TRUNC(Wavelength) OF
    380..439: BEGIN
        Red   := -(Wavelength - 440) / (440 - 380);
        Green := 0.0;
        Blue  := 1.0
      END;
    440..489: BEGIN
        Red   := 0.0;
        Green := (Wavelength - 440) / (490 - 440);
        Blue  := 1.0
      END;
    490..509: BEGIN
        Red   := 0.0;
        Green := 1.0;
        Blue  := -(Wavelength - 510) / (510 - 490)
      END;
    510..579: BEGIN
        Red   := (Wavelength - 510) / (580 - 510);
        Green := 1.0;
        Blue  := 0.0
      END;
    580..644: BEGIN
        Red   := 1.0;
        Green := -(Wavelength - 645) / (645 - 580);
        Blue  := 0.0
      END;
    645..780: BEGIN
        Red   := 1.0;
        Green := 0.0;
        Blue  := 0.0
      END;
    ELSE begin
      Red   := 0.0;
      Green := 0.0;
      Blue  := 0.0
    end;
  END;
  // Let the intensity fall off near the vision limits
  CASE TRUNC(Wavelength) OF
    380..419:  factor := 0.1 + 0.9*(Wavelength - 380) / (420 - 380);
// 0.1  1
    420..700:  factor := 1.0;
    701..780:  factor := 0.1 + 0.9*(780 - Wavelength) / (780 - 700)
// 0.1  1
    ELSE       factor := 0.0
  END;
  R := Adjust(Red,   Factor);
  G := Adjust(Green, Factor);
  B := Adjust(Blue,  Factor);
  result :=  RGB(R,G,B);
END {WavelengthToColor};

initialization
   mesDocsDir := GetFolder(CSIDL_Personal);
   if not DirectoryExists(MesDocsDir+'Regressi') then
       createDir(MesDocsDir+'Regressi');
   mesDocsDir := MesDocsDir+'Regressi\';
//   AppData := GetFolder(CSIDL_APPDATA);
//   AppData := GetFolder(CSIDL_LOCAL_APPDATA);
   AppData := GetFolder(CSIDL_COMMON_APPDATA);
   if not DirectoryExists(AppData+'Regressi') then
       createDir(AppData+'Regressi');
   AppData := AppData+'Regressi\';
end.

