unit oneInst;

interface

uses
  Windows, Forms, SysUtils, Messages;

const WM_Focus = WM_USER + 1;

implementation

var hSemaphore : integer;

procedure EnsureSingleInstance;
var
  Wnd : HWnd;
  WndClass, WndText: array[0..255] of char;
begin
{ Try and create a semaphore. If we succeed, then check
  if the semaphore was already present. If it was
  then a previous instance is floating around.
  Note the OS will free the returned semaphore handle
  when the app shuts so we can forget about it }
  hSemaphore := CreateSemaphore(nil,0,1,'Biochrom');
  if (hSemaphore<>0) and
     (GetLastError = Error_Already_Exists) then begin
    Wnd := GetWindow(Application.Handle,gw_HWndFirst);
    while Wnd <> 0 do begin
      { Look for the other TApplication window out there }
      if Wnd <> Application.Handle then begin
        { Check it's definitely got the same class and caption }
        GetWindowText(Wnd, WndText, Succ(Length(Application.Title)));
        GetClassName(Wnd, WndClass, Pred(SizeOf(WndClass)));
        if (StrPas(WndClass) = Application.ClassName) and
           (StrPas(WndText) = Application.Title) then begin
          { This technique is used by the VCL: post }
          { a message then bring the window to the }
          { top, before the message gets processed }
          PostMessage(Wnd, wm_SysCommand, sc_Restore, 0);
          SetForeGroundWindow(Wnd);
          PostMessage(Wnd,WM_Focus, 0, 0);
          Halt
        end
      end;
      Wnd := GetWindow(Wnd, gw_HWndNext);
    end
  end
end;

initialization
  EnsureSingleInstance
end.
