unit spectrobeer;

interface

uses Windows, Classes, Graphics, Forms, Controls, Menus,
  Dialogs, StdCtrls, Buttons, ExtCtrls, sysUtils, Messages, clipBrd,
  spin, grids,ComCtrls,ImgList, ToolWin, inifiles,
  graphker, jmmUtil, spectroCfg, GripSplitter;

type
  TBeerForm = class(TForm)
    Panel1: TPanel;
    LabelPb: TLabel;
    Oscillo: TPaintBox;
    BeerMesureGrid: TStringGrid;
    beerCalcGrid: TStringGrid;
    ToolBar1: TToolBar;
    RegSaveBtn: TToolButton;
    ModeBtn: TToolButton;
    ResetBtn: TToolButton;
    UndoBtn: TToolButton;
    Label1: TLabel;
    LambdaSE: TSpinEdit;
    ZeroBtn: TToolButton;
    EnregistreBtn: TToolButton;
    ExitBtn: TToolButton;
    ToolButton1: TToolButton;
    StatusBar1: TStatusBar;
    AbsPanel: TPanel;
    Label3: TLabel;
    PanelBlanc: TPanel;
    Label4: TLabel;
    ConnectBtn: TToolButton;
    ZoomBtn: TToolButton;
    SpectreBtn: TToolButton;
    SpectrePB: TPaintBox;
    GripSplitter1: TGripSplitter;
    SavePopupMenu: TPopupMenu;
    RegressiM: TMenuItem;
    ClipM: TMenuItem;
    FileM: TMenuItem;
    CalcSplit: TSplitter;
    procedure ExitItemClick(Sender: TObject);
    procedure AboutItemClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure AcquisitionItemClick(Sender: TObject);
    procedure OscilloPaint(Sender: TObject);
    procedure RegSaveBtnClick(Sender: TObject);
    procedure ResetBtnClick(Sender: TObject);
    procedure EnregistreBtnClick(Sender: TObject);
    procedure UndoBtnClick(Sender: TObject);
    procedure FormResize(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure FormActivate(Sender: TObject);
    procedure ZeroBtnClick(Sender: TObject);
    procedure PrintBtnClick(Sender: TObject);
    procedure BeerMesureGridSelectCell(Sender: TObject; ACol, ARow: Integer;
      var CanSelect: Boolean);
    procedure BeerMesureGridGetEditText(Sender: TObject; ACol, ARow: Integer;
      var Value: string);
    procedure BeerMesureGridKeyPress(Sender: TObject; var Key: Char);
    procedure BeerMesureGridKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure beerCalcGridSelectCell(Sender: TObject; ACol, ARow: Integer;
      var CanSelect: Boolean);
    procedure ConnectBtnClick(Sender: TObject);
    procedure ZoomBtnClick(Sender: TObject);
    procedure SpectreBtnClick(Sender: TObject);
    procedure SpectrePBMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure SpectrePBMouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure SpectrePBMouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure SpectrePBPaint(Sender: TObject);
    procedure LambdaSEChange(Sender: TObject);
    procedure RegressiMClick(Sender: TObject);
    procedure FormKeyPress(Sender: TObject; var Key: Char);
  private
    SpectreGraphe : Tgraphe;
    DejaSauve : boolean;
    premiereFois : boolean;
    valeurClavier : double;
    BlancFait : boolean;
    pente : double;
    titreEcart : shortString;
    AbsCalc,ConcCalc : vecteur;
    NbreCalc : integer;
    RowEdit : integer;
    DernierPointCalc : boolean; // calcul par la loi de Beer Lambert
    Curseur : TcurseurCinetique;
    valeurCourante : double;
    spectreSeul : boolean;
    Procedure setBoutons;
    Procedure MarquePoint(i : indiceVecteur);
    procedure SetFocusGrid;
    procedure CalcPente;
    procedure DesactiveBoutons;
    procedure setValeurClavier(verif : boolean);
    procedure FinBlanc;
    procedure FinSpectre;
    procedure FinSpectreCalc;
    procedure FinSpectreSeul;
    procedure avail_Lambda_Abs(Lambda : integer;abs : double);    
  public
      Graphe : Tgraphe;
      procedure SpectroChange;
  protected
  end;

var
  BeerForm: TBeerForm;

implementation

uses About, SpectroDDE, Spectromain, modebeer, Spectrocst;

{$R *.DFM}

procedure TBeerForm.ExitItemClick(Sender: TObject);
begin
    Close
end;

procedure TBeerForm.AboutItemClick(Sender: TObject);
begin
    AboutBox.ShowModal
end;

procedure TBeerForm.FormCreate(Sender: TObject);
begin
  DejaSauve := true;
  RowEdit := 0;
  Graphe := Tgraphe.Create;
  with graphe.mondeY do begin
     nom := 'A';
     unite := '';
     signif := stAbs;
  end;
  with graphe.mondeX do begin
     nom := spectroBiochrom.nomC;
     unite := spectroBiochrom.uniteC;
     signif := spectroBiochrom.signifC;
  end;
  with graphe do begin
     with spectroBiochrom do setMonde(MiniC,0,MaxiC,AbsMax);
     Trace := trPoint;
     limiteCourbe := Oscillo.clientRect;
     Canvas := Oscillo.Canvas;
     NbrePoints := 0;
     NbreCalc := 0;
  end;
  SpectreGraphe := Tgraphe.Create;
  with SpectreGraphe do begin
       mondeX.unite := 'nm';
       mondeX.nom := 'Lambda';
       mondeX.signif := stLambda;
       mondeY.nom := 'A';
       mondeY.unite := '';
       mondeY.signif := stAbs;
       with spectroBiochrom do setMonde(LambdaMin,0,LambdaMax,AbsMax);
       trace := trSpectre;
       canvas := spectrePB.Canvas;
       avecAxeY := false;
  end;
  LambdaSE.minValue := round(spectroBiochrom.LambdaMin);
  LambdaSE.maxValue := round(spectroBiochrom.LambdaMax);
  LambdaSE.value := spectroBiochrom.LambdaBeer;
  BlancFait := false;
  BeerCalcGrid.font.color := couleurCalc;
  premiereFois := true;
end;

procedure TBeerForm.AcquisitionItemClick(Sender: TObject);
begin
     if ModeBeerDlg=nil then
        Application.CreateForm(TModeBeerDlg, ModeBeerDlg);
     ModeBeerDlg.showModal;
     with graphe.mondeX do begin
       nom := spectroBiochrom.nomC;
       unite := spectroBiochrom.uniteC;
       signif := spectroBiochrom.signifC;
       mini := spectroBiochrom.miniC;
       maxi := spectroBiochrom.maxiC;
     end;
     Oscillo.Refresh;
     setBoutons;
end;

procedure TBeerForm.beerCalcGridSelectCell(Sender: TObject; ACol, ARow: Integer;
  var CanSelect: Boolean);
begin
	dernierPointCalc := true;
    canSelect := false;
    setBoutons;
end;

procedure TBeerForm.BeerMesureGridGetEditText(Sender: TObject; ACol,
  ARow: Integer; var Value: string);
begin
   if acol=0
      then case arow of
         0 : value := graphe.MondeX.nom;
         1 : value := graphe.MondeX.unite;
         else begin
            arow := arow-2;
            if arow>=graphe.NbrePoints
               then value := ''
               else value := FloatToStr(graphe.valeurX[arow]);
         end
      end
      else case arow of
          0 : value := graphe.MondeY.nom;
          1 : value := graphe.MondeY.unite;
          else begin
              arow := arow-2;
              if arow>=graphe.NbrePoints
                then value := ''
                else value := FloatToStr(graphe.data.valeurY[arow])
          end;
     end;

end;

procedure TBeerForm.BeerMesureGridKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
    if key=vk_return then
        setValeurClavier(true)
end;

procedure TBeerForm.BeerMesureGridKeyPress(Sender: TObject; var Key: Char);
begin with BeerMesureGrid do
    if (col=0) and(row>0)
        then if key in [',','.']
           then key := decimalSeparator
           else begin
              if not ( key in (ChiffreWin+ToucheEdition) ) then key := #0
           end
        else key := #0
end;

procedure TBeerForm.BeerMesureGridSelectCell(Sender: TObject; ACol,
  ARow: Integer; var CanSelect: Boolean);
begin
    CanSelect := (Acol=0) and (Arow>1);
    if CanSelect then rowEdit := Arow;
    dernierPointCalc := false;
end;

procedure TBeerForm.OscilloPaint(Sender: TObject);
var
   maxAbsCalc,maxConcCalc : double;

procedure MaxiCalc;
var
   j: integer;
begin
   maxAbsCalc := 0;
   maxConcCalc := 0;
   for j := 0 to pred(NbreCalc) do begin
      if absCalc[j] > maxAbsCalc then
         maxAbsCalc := absCalc[j];
      if concCalc[j] > maxConcCalc then
         maxConcCalc := concCalc[j];
   end;
  if maxAbsCalc<0.01 then MaxAbsCalc := 0.1;
end;

var x0,y0,x1,y1,i : integer;
    AbsMax : double;
begin with graphe,data do begin
     limiteFenetre := Oscillo.clientRect;
     if NbrePoints>0
        then begin
           AbsMax := MaxiY*1.05;
           if AbsMax<0.1 then AbsMax := 1;
           if (MondeY.Maxi<AbsMax) then MondeY.maxi := AbsMax;
           if (MondeY.Maxi>1) and (MondeY.Maxi<AbsMax) then MondeY.maxi := AbsMax;
           if spectroBiochrom.BeerActif then begin
              MaxiCalc;
              if (MondeX.Maxi<maxConcCalc) then MondeX.maxi := MaxConcCalc;
              if (MondeY.Maxi<maxAbsCalc) then MondeY.maxi := MaxAbsCalc;
           end;
        end
        else MondeY.maxi := 1;
     Draw;
     BeerMesureGrid.cells[0,0] := mondeX.nom;
     BeerMesureGrid.cells[1,0] := mondeY.nom;
     BeerMesureGrid.cells[0,1] := mondeX.Unite;
     BeerMesureGrid.cells[1,1] := mondeY.Unite;
     if BeerMesureGrid.rowCount<(NbrePoints+3) then
         BeerMesureGrid.rowCount := NbrePoints+5;
     for i := 0 to pred(NbrePoints) do begin
         BeerMesureGrid.cells[0,i+2] := FormatCourt(valeurX[i]);
         BeerMesureGrid.cells[1,i+2] := spectroBiochrom.FormatAbs(valeurY[i]);
     end;
     BeerMesureGrid.row := NbrePoints+2;
     for i := NbrePoints+2 to pred(BeerMesureGrid.RowCount) do begin
         BeerMesureGrid.cells[0,i] := '';
         BeerMesureGrid.cells[1,i] := '';
     end;
     if (spectroBiochrom.BeerActif) and (NbrePoints>2) then begin
        calcPente;
        if BeerCalcGrid.rowCount<(NbreCalc+1) then
           BeerCalcGrid.rowCount := NbreCalc+3;
        if pente>sansSignif then begin
           windowXY(0,0,x0,y0);
           windowXY(mondeX.maxi,MondeX.maxi*pente,x1,y1);
           if y1<limiteFenetre.top then
              WindowXY(mondeY.maxi/pente,MondeY.maxi,x1,y1);
           Oscillo.canvas.moveTo(x0,y0);
           Oscillo.canvas.lineTo(x1,y1);
           for i := 0 to pred(Nbrecalc) do begin
               BeerCalcGrid.cells[0,i] := FormatCourt(concCalc[i]);
               BeerCalcGrid.cells[1,i] := spectroBiochrom.FormatAbs(absCalc[i]);
               tracePointCalc(concCalc[i],absCalc[i]);
           end;
        end
        else begin
           for i := 0 to pred(NbreCalc) do begin
               BeerCalcGrid.cells[0,i] := '?';
               BeerCalcGrid.cells[1,i] := spectroBiochrom.FormatAbs(absCalc[i]);
           end;
        end;
        for i := NbreCalc to pred(BeerCalcGrid.RowCount) do begin
            BeerCalcGrid.cells[0,i] := '';
            BeerCalcGrid.cells[1,i] := '';
        end;
     end;
     if titreEcart<>'' then canvas.TextOut(graphe.LimiteCourbe.left+8,8,titreEcart);
     spectrePB.refresh;
end end;

procedure TBeerForm.RegressiMClick(Sender: TObject);
begin
    regSaveBtn.ImageIndex := (sender as TmenuItem).imageIndex;
   (sender as TmenuItem).checked := true;
    regSaveBtn.caption := captionSauve[(sender as TmenuItem).tag];
    regSaveBtnClick(sender);
end;

procedure TBeerForm.RegSaveBtnClick(Sender: TObject);
begin
   graphe.tri;
   if regressiM.Checked and
      (ConstanteDlg.showModal=mrOk) then begin
        FormDDE.EnvoieDonneesBeer(true);
        constanteDlg.newPageCB.itemIndex := 1;
        DejaSauve := true;
    end;
    if clipM.Checked then begin
        FormDDE.EnvoieDonneesBeer(false);
        DejaSauve := true;
    end;
    if fileM.Checked  and
       FormMain.SaveDialog.execute then begin
          FormDDE.SaveBeer(FormMain.SaveDialog.fileName);
          DejaSauve := true;
    end;
end;

procedure TBeerForm.DesactiveBoutons;
begin
     ZeroBtn.enabled := false;
     LambdaSE.enabled := false;
     EnregistreBtn.enabled := false;
     Screen.cursor := crHourGlass;
     Application.processMessages;
end;

procedure TBeerForm.SetBoutons;
begin
     connectBtn.enabled := not spectroBiochrom.spectroBusy;
     if spectroBiochrom.spectroBusy
        then Screen.cursor := crHourGlass
        else Screen.cursor := crDefault;
     ZeroBtn.enabled := true;
     LambdaSE.enabled := graphe.NbrePoints=0;
     spectrePB.enabled := LambdaSE.enabled;
     BeerMesureGrid.enabled := blancFait;
     SpectreBtn.enabled := blancFait;
     PanelBlanc.Visible := not blancFait;
     RegSaveBtn.visible := graphe.NbrePoints>2;
     UndoBtn.visible := graphe.NbrePoints>0;
     BeerMesureGrid.Hint := stTaper+graphe.mondeX.nom+stValiderAbs;
     EnregistreBtn.visible := spectroBiochrom.BeerActif;
     SetFocusGrid;
     EnregistreBtn.enabled := spectroBiochrom.BeerActif and
                              (graphe.NbrePoints>2) and
                              not spectroBiochrom.spectroBusy;
     EnregistreBtn.caption := graphe.mondeX.nom + ' ?';
     EnregistreBtn.hint := hAbsInconnue;
     if spectroBiochrom.BeerActif and
          (graphe.NbrePoints>2)
          then begin
               BeerCalcGrid.visible := true;
               CalcSplit.visible := true;
          end
          else begin
               BeerCalcGrid.visible := false;
               CalcSplit.visible := false;
          end;
     if dernierPointCalc
        then UndoBtn.hint := hDelCalc
        else UndoBtn.hint := hDelClavier;
end;

procedure TBeerForm.SpectroChange;
begin
     EnregistreBtn.enabled := spectroBiochrom.BeerActif and
                              (graphe.NbrePoints>2);
     BeerCalcGrid.visible := spectroBiochrom.BeerActif and (graphe.NbrePoints>2);
	if spectroBioChrom.connecte
    then begin
          connectBtn.caption := stDeconnect;
          connectBtn.hint := stTouches;
          connectBtn.down := false;
          connectBtn.imageIndex := 11;
    end
    else begin
          connectBtn.caption := stConnect;
          connectBtn.hint := stRemote;
          connectBtn.down := true;
          connectBtn.imageIndex := 12;
    end
end;

procedure TBeerForm.SpectreBtnClick(Sender: TObject);
begin
    SpectreGraphe.NbrePoints := 0;
    label3.caption := stAcqSpectre;
    spectreSeul := true;
    DesactiveBoutons;
    spectroBiochrom.lanceSpectre(finSpectreSeul,avail_lambda_abs);
end;

procedure TBeerForm.SpectrePBMouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
var xi,yi : integer;  
begin with spectreGraphe do begin
   curseur := curNone;
   windowXY(spectroBiochrom.lambdaBeer,0,xi,yi);
   if (abs(xi-x)<4) then begin
       curseur := curLambda;
       spectrePB.hint := 'Rglage de lambda';
       spectrePB.cursor := crHSplit;
   end;
   if curseur=curNone then spectrePB.cursor := crDefault;
end end;

procedure TBeerForm.SpectrePBMouseMove(Sender: TObject; Shift: TShiftState; X,
  Y: Integer);
var xi,yi : integer;
    xr,yr : double;
begin with spectreGraphe do begin
   if curseur=curNone
       then begin
            windowXY(spectroBiochrom.lambdaBeer,0,xi,yi);
            if (abs(xi-x)<4) then begin
               spectrePB.hint := 'Rglage de lambda';
               spectrePB.cursor := crHsplit;
            end
            else begin
               spectrePB.hint := '';
               spectrePB.cursor := crDefault;
            end
        end
        else if ssLeft in Shift then begin
              MondeXY(X,Y,xr,yr);
              xi := round(xr);
              LambdaSE.value := xi;
        end;
end end;

procedure TBeerForm.SpectrePBMouseUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
var xr,yr : double;  
begin
   if curseur=curLambda then with spectreGraphe do begin
      MondeXY(X,Y,xr,yr);
      lambdaSE.value := round(xr);
      curseur := curNone;
      spectrePB.cursor := crDefault;
      spectrePB.hint := '';
   end;
end;

procedure TBeerForm.SpectrePBPaint(Sender: TObject);
var xi,yi : integer;
begin with SpectreGraphe do begin
    limiteFenetre := SpectrePB.clientRect;
    mondeY.maxi := graphe.mondeY.maxi;
    Draw;
    canvas.pen.color := WaveLengthToColor(spectroBiochrom.lambdaBeer);
    canvas.pen.width := 3;
    WindowXY(spectroBiochrom.lambdaBeer,0,xi,yi);
    canvas.moveTo(xi,0);
    canvas.lineTo(xi,spectrePB.height);
end end;

procedure TBeerForm.ResetBtnClick(Sender: TObject);
begin
     graphe.NbrePoints := 0;
     SpectreGraphe.NbrePoints := 0;
     NbreCalc := 0;
     Oscillo.refresh;
     setBoutons;
end;

procedure TBeerForm.FinSpectreCalc;
begin with graphe,data do begin
         spectrePB.refresh;
         if valeurCourante=sansSignif then begin
            showMessage(stBadBlanc);
            Label3.caption := stBadAbs;
            setBoutons;
            exit;
         end;
         Label3.caption := '';
         calcPente;
         if pente<SansSignif then begin
            showMessage(stBadData);
            absCalc[NbreCalc] := valeurCourante;
            if BeerCalcGrid.rowCount<(NbreCalc+1) then
               BeerCalcGrid.rowCount := NbreCalc+1;
            BeerCalcGrid.cells[1,NbreCalc] := spectroBiochrom.FormatAbs(valeurCourante);
            inc(NbreCalc);
            setBoutons;
            exit;
         end;
         absCalc[NbreCalc] := valeurCourante;
         concCalc[NbreCalc] := valeurCourante/pente;
         if BeerCalcGrid.rowCount<(NbreCalc+1) then
            BeerCalcGrid.rowCount := NbreCalc+1;
         BeerCalcGrid.cells[0,NbreCalc] := FormatCourt(concCalc[NbreCalc]);
         BeerCalcGrid.cells[1,NbreCalc] := spectroBiochrom.FormatAbs(valeurCourante);
         tracePointCalc(concCalc[NbreCalc],absCalc[NbreCalc]);
         inc(NbreCalc);
         setBoutons;
end end;

procedure TBeerForm.ZoomBtnClick(Sender: TObject);

procedure Zoom;
var j : integer;
    max : double;
begin with graphe do begin
    max := 0;
    for j := 0 to pred(NbrePoints) do
        if data.valeurY[j]>max then max := data.valeurY[j];
    max := max*1.05;
    if max>spectroBiochrom.absMax then max := spectroBiochrom.absMax;
    if max<0.2 then max := 0.2;
    mondeY.maxi := max;
end end;

begin
    if zoomBtn.down and (graphe.NbrePoints>1)
       then zoom
       else graphe.mondeY.maxi := spectroBiochrom.absMax;
    oscillo.refresh;
end;

procedure TBeerForm.EnregistreBtnClick(Sender: TObject);
begin
      DesactiveBoutons;
      SpectreGraphe.NbrePoints := 0;
      Label3.caption := stAcqSpectre;
      spectreSeul := false;
      spectroBiochrom.lanceSpectre(finSpectreCalc,avail_lambda_abs);
end;

procedure TBeerForm.UndoBtnClick(Sender: TObject);
var i,j : integer;
begin  // Supprimer le dernier point 
     if not dernierPointCalc and
        (graphe.NbrePoints>0) and
        (BeerMesureGrid.col=0) and
        (BeerMesureGrid.row>1) and
        (BeerMesureGrid.row<(graphe.NbrePoints+2))
        then begin
             i := BeerMesureGrid.row-2;
             for j := i to pred(graphe.NbrePoints) do begin
                 graphe.valeurX[j] := graphe.valeurX[j+1];
                 graphe.data.valeurY[j] := graphe.data.valeurY[j+1];
             end;
             dec(graphe.NbrePoints);
             setBoutons;
             Oscillo.refresh;
       end;
     if dernierPointCalc and
        spectroBiochrom.BeerActif and
        (BeerCalcGrid.col=0) and
        (BeerCalcGrid.row<NbreCalc)
           then begin
             i := BeerCalcGrid.row;
             for j := i to pred(NbreCalc) do begin
                 AbsCalc[j] := AbsCalc[j+1];
                 ConcCalc[j] := ConcCalc[j+1];
             end;
             dec(NbreCalc);
             setBoutons;
             Oscillo.refresh;
           end;
end;

procedure TBeerForm.FormResize(Sender: TObject);
begin
     Graphe.limiteCourbe := Oscillo.clientRect
end;

procedure TBeerForm.LambdaSEChange(Sender: TObject);
begin
    spectroBiochrom.lambdaBeer := LambdaSE.value;
    spectrePB.refresh;
end;

procedure TBeerForm.setValeurClavier;
begin with graphe.mondeX do begin
        try
        valeurClavier := StrToFloatWin(BeerMesureGrid.Cells[0,rowEdit]);
        if (valeurClavier>maxi) or (valeurClavier<mini) then
            if OKreg(FormatCourt(valeurClavier)+
                      ' avec mini='+FormatCourt(mini)+
                      ' et maxi='+FormatCourt(maxi)+#13#10+
                      stConfirm)
               then begin
                    if (valeurClavier>maxi) then maxi := valeurClavier;
                    if (valeurClavier<mini) then mini := valeurClavier;
                    oscillo.refresh;
               end
               else begin
                  setFocusGrid;
                  exit;
               end;
        DesactiveBoutons;
        Label3.caption := stAcqSpectre;
        SpectreGraphe.NbrePoints := 0;
        spectreSeul := false;                
        spectroBiochrom.lanceSpectre(finSpectre,avail_lambda_abs);
        except
            ValeurClavier := sansSignif;
            if verif then begin
               showMessage(stBadNombre);
               setFocusGrid;
            end;
        end;
     end
end;

procedure TBeerForm.finSpectre;
begin
spectrePB.refresh;
label3.caption := '';
if (rowEdit<2) then exit;
with graphe,data do begin
      valeurX[RowEdit-2] := valeurClavier;
      if valeurCourante=sansSignif then begin
         showMessage(stBadBlanc);
         Label3.caption := stbadAbs;
         setBoutons;
         exit;
      end;
      Label3.caption := '';
      valeurY[RowEdit-2] := valeurCourante;
      MarquePoint(RowEdit-2);
      setBoutons;
      if EnregistreBtn.visible then oscillo.refresh;
      if (rowEdit<=succ(NbrePoints)) then setFocusGrid;
end end;

procedure TBeerForm.FormDestroy(Sender: TObject);
begin
     graphe.free
end;

procedure TBeerForm.FormKeyPress(Sender: TObject; var Key: Char);
begin
     if (key=' ') then begin
         if not blancFait then begin
            zeroBtnClick(sender);
            key := #0;
         end;
         if enregistreBtn.enabled then begin
            enregistreBtnClick(sender);
            key := #0;
         end;
     end;
end;

procedure TBeerForm.FormClose(Sender: TObject; var Action: TCloseAction);

procedure WriteFormPlacement;
var
  ini : TMemIniFile;
begin
  try
  Ini := TmemIniFile.create(FormMain.NomFichierIni);
  Ini.WriteInteger('WindowB','State',ord(WindowState));
  Ini.WriteInteger('WindowB','Height',height);
  Ini.WriteInteger('WindowB','Width',width);
  Ini.WriteInteger('WindowB','Top',top);
  Ini.WriteInteger('WindowB','Left',left);
  ini.UpdateFile;
  Ini.free;
  except
  end;
end;

begin
    if (graphe.NbrePoints>2) and
        not DejaSauve and
        OKreg(stSauve)
        then RegSaveBtnClick(sender);
    writeFormPlacement;
    FormMain.setMode(mNone);
end;

procedure TBeerForm.FormActivate(Sender: TObject);
var ini : TiniFile;
begin
     if premiereFois then begin
        if FileExists(FormMain.NomFichierIni) then begin
        try
        Ini := TIniFile.create(FormMain.NomFichierIni);
        WindowState := TwindowState(Ini.ReadInteger('WindowB','State',ord(wsMaximized)));
        Height := Ini.ReadInteger('WindowB','Height',height);
        Width := Ini.ReadInteger('WindowB','Width',width);
        Top := Ini.ReadInteger('WindowB','Top',top);
        Left := Ini.ReadInteger('WindowB','Left',left);
        Ini.free;
        except
        end;
        end;
     end; // premiereFois
     premiereFois := false;
     Label3.caption := '';
     Oscillo.Refresh;
     gripSplitter1.snapped := true;
     setBoutons;
end;

procedure TBeerForm.MarquePoint(i : indiceVecteur);
begin
     graphe.traceUnPoint(i,graphe.data);
     if (i=graphe.NbrePoints) then
         inc(graphe.NbrePoints);
     if BeerMesureGrid.rowCount<(i+4) then
        BeerMesureGrid.rowCount := i+4;
     BeerMesureGrid.cells[0,i+2] := FormatCourt(graphe.valeurX[i]);
     BeerMesureGrid.cells[1,i+2] := spectroBiochrom.FormatAbs(graphe.data.valeurY[i]);
     BeerMesureGrid.row := i+3; // point suivant
     BeerMesureGrid.col := 0;      
end;

procedure TBeerForm.ZeroBtnClick(Sender: TObject);
begin
    DesactiveBoutons;
    Label3.caption := stBlanc;
    spectreGraphe.nbrePoints := 0;
    spectrePB.refresh;
    spectroBiochrom.lanceZero(finBlanc);
end;

procedure TBeerForm.PrintBtnClick(Sender: TObject);
begin
     graphe.imprime
end;

procedure TBeerForm.SetFocusGrid;
var i : integer;
begin
       if not BeerMesureGrid.enabled then exit;       
       i := graphe.NbrePoints;
       if BeerMesureGrid.rowCount<i+3 then
          BeerMesureGrid.rowCount := i+3;
       BeerMesureGrid.cells[0,i+2] := '';
       BeerMesureGrid.cells[1,i+2] := '';
       BeerMesureGrid.col := 0;
       BeerMesureGrid.row := i+2;
       rowEdit := i+2;
       BeerMesureGrid.setFocus;
       BeerMesureGrid.editorMode := true;
end;

procedure TbeerForm.calcPente;
var i,nbre : integer;
    AbsTot,cTot,ecart : double;
begin
      TitreEcart := '';
      if EnregistreBtn.enabled then with graphe do begin
         pente := 0;
         Nbre := 0;
         AbsTot := 0;
         cTot := 0;
         for i := 0 to pred(NbrePoints) do
             if (valeurX[i]>1e-9) and (data.valeurY[i]>0) then begin
                AbsTot := AbsTot+data.valeurY[i];
                cTot := cTot+valeurX[i];
                inc(Nbre);
             end;
         if nbre>0 then begin
            pente := AbsTot/cTot;
            for i := 0 to pred(NbreCalc) do
                concCalc[i] := absCalc[i]/pente;
            ecart := 0;
            Nbre := 0;
            for i := 0 to pred(NbrePoints) do
                   if (valeurX[i]>1e-9) and
                      (data.valeurY[i]>1e-3) then begin
                      ecart := ecart+sqr(data.valeurY[i]-
                               pente*valeurX[i]);
                   inc(Nbre);
            end;
            ecart := sqrt(ecart/Nbre);
            TitreEcart := stPrecisionAbs+FormatPrec(ecart);
         end
         else begin
            pente := sansSignif;
            for i := 0 to pred(NbreCalc) do
                concCalc[i] := sansSignif;
         end;
end end;

procedure TBeerForm.ConnectBtnClick(Sender: TObject);
begin
	if spectroBioChrom.connecte
       then spectroBiochrom.release
       else spectroBiochrom.control;
end;

procedure TBeerForm.FinBlanc;
begin
   Label3.caption := '';
   blancFait := true;
   setBoutons;
end;

procedure TBeerForm.FinSpectreSeul;
begin
     gripSplitter1.snapped := false;
     label3.caption := '';
     spectrePB.refresh;
     SetBoutons;
end;

procedure TBeerForm.Avail_Lambda_Abs(Lambda : integer;abs : double);
begin
     with SpectreGraphe do begin
          valeurX[NbrePoints] := lambda;
          data.valeurY[NbrePoints] := abs;
          if NbrePoints=0 then if spectreSeul
             then label3.caption := stLectureSpectre
             else label3.caption := stLectureAbs;
          if lambda=spectroBiochrom.lambdaBeer then valeurCourante := abs;
          inc(NbrePoints);
     end;
end;

end.


