unit spectrocinet;

interface

uses Windows, Classes, Graphics, Forms, Controls, Menus,
  Dialogs, StdCtrls, Buttons, ExtCtrls, sysUtils, Messages,
  clipBrd, spin, ComCtrls, ImgList, ToolWin, inifiles,
  graphker, jmmUtil, spectroCfg, spectromain, Lcd, GripSplitter;

type
  TCinetiqueForm = class(TForm)
    Oscillo: TPaintBox;
    AcqPanel: TPanel;
    ToolBar1: TToolBar;
    RegSaveBtn: TToolButton;
    ResetBtn: TToolButton;
    StopBtn: TToolButton;
    ExitBtn: TToolButton;
    PrintBtn: TToolButton;
    PanelParam: TPanel;
    LabelDeltat: TLabel;
    Label3: TLabel;
    NbreEdit: TEdit;
    DureeEdit: TEdit;
    Label2: TLabel;
    PanelDuree: TPanel;
    AbsLCDbis: TLCD99;
    LabelAbsBis: TLabel;
    TimerSpectre: TTimer;
    LambdaBisCB: TCheckBox;
    StatusBar1: TStatusBar;
    ConnectBtn: TToolButton;
    BlancBtn: TToolButton;
    LabelAbs: TLabel;
    AbsLCD: TLCD99;
    PanelBlanc: TPanel;
    Label1: TLabel;
    startBtn: TToolButton;
    TimerHorloge: TTimer;
    LabelTemps: TLabel;
    ZoomBtn: TToolButton;
    LambdaBisSE: TUpDown;
    LambdaBisEdit: TEdit;
    LambdaEdit: TEdit;
    LambdaSE: TUpDown;
    DeltatEdit: TEdit;
    DeltatSE: TUpDown;
    NbreSE: TUpDown;
    Edit1: TEdit;
    SpectrePB: TPaintBox;
    GripSplitter1: TGripSplitter;
    SpectreBtn: TToolButton;
    SavePopupMenu: TPopupMenu;
    RegressiM: TMenuItem;
    ClipM: TMenuItem;
    FileM: TMenuItem;
    procedure FormCreate(Sender: TObject);
    procedure StartBtnClick(Sender: TObject);
    procedure OscilloPaint(Sender: TObject);
    procedure StopBtnClick(Sender: TObject);
    procedure RegSaveBtnClick(Sender: TObject);
    procedure ResetBtnClick(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure ExitBtnClick(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure PrintBtnClick(Sender: TObject);
    procedure BlancBtnClick(Sender: TObject);
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
    procedure TimerSpectreTimer(Sender: TObject);
    procedure ConnectBtnClick(Sender: TObject);
    procedure FormActivate(Sender: TObject);
    procedure FormKeyPress(Sender: TObject; var Key: Char);
    procedure TimerHorlogeTimer(Sender: TObject);
    procedure LambdaBisCBClick(Sender: TObject);
    procedure ZoomBtnClick(Sender: TObject);
    procedure NbreEditKeyPress(Sender: TObject; var Key: Char);
    procedure DeltatSEChanging(Sender: TObject; var AllowChange: Boolean);
    procedure NbreSEChanging(Sender: TObject; var AllowChange: Boolean);
    procedure NbreEditChange(Sender: TObject);
    procedure NbreSEChangingEx(Sender: TObject; var AllowChange: Boolean;
      NewValue: Smallint; Direction: TUpDownDirection);
    procedure DeltatSEChangingEx(Sender: TObject; var AllowChange: Boolean;
      NewValue: Smallint; Direction: TUpDownDirection);
    procedure SpectrePBPaint(Sender: TObject);
    procedure LambdaSEChangingEx(Sender: TObject; var AllowChange: Boolean;
      NewValue: Smallint; Direction: TUpDownDirection);
    procedure SpectreBtnClick(Sender: TObject);
    procedure SpectrePBMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure SpectrePBMouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure SpectrePBMouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure RegressiMClick(Sender: TObject);
  private
    EtatAcq  : TetatCinetique;
    DejaSauve : boolean;
    DebutAcq,instantLecture : TdateTime;
    blancFait : boolean;
    relancerSpectre : boolean;
    premiereFois : boolean;
    stopEnCours : boolean;
    SpectreTemps : Matrice;
    pasSpectreTemps : integer;
    Curseur : TcurseurCinetique;
    Procedure setBoutons(etat : TEtatCinetique);
    procedure FinSpectre;
    procedure FinSpectreSeul;
    procedure FinBlanc;
    procedure avail_Lambda_Abs(Lambda : integer;abs : double);
    procedure LanceMesure;
  public
      Graphe : Tgraphe;
      SpectreGraphe : Tgraphe;
      Procedure spectroChange;
  protected
  end;

var
  CinetiqueForm: TCinetiqueForm;

implementation

uses SpectrodDE, spectrocst;

const minPoints = 4;
      deltatMax = 60;      

{$R *.DFM}

function IsValidChar(Key: Char): Boolean;
begin
     Result := (Key in ['0'..'9']) or (Key < #32);
end;

procedure TCinetiqueForm.FormCreate(Sender: TObject);
begin
  Graphe := Tgraphe.Create;
  graphe.trace := trLignePoint;
  Graphe.Canvas := Oscillo.Canvas;
  DejaSauve := false;                                
  with graphe do begin
     mondeX.nom := 't';
     mondeY.nom := 'A';
     mondeX.signif := stTemps;
     mondeY.signif := stAbs;
     mondeX.unite := 's';mondeY.unite := '';
     with spectroBiochrom do setMonde(0,0,dureeCinetique,AbsMax);
  end;
  SpectreGraphe := Tgraphe.Create;
  with Spectregraphe do begin
       mondeX.unite := 'nm';
       mondeX.nom := 'Lambda';
       mondeX.signif := stLambda;
       mondeY.nom := 'A';
       mondeY.unite := '';
       mondeY.signif := stAbs;
       with spectroBiochrom do setMonde(LambdaMin,0,LambdaMax,AbsMax);
       trace := trSpectre;
       canvas := spectrePB.Canvas;
       avecAxeY := false;
  end;
  SpectrePB.canvas.font.pitch := fpDefault;
  LambdaSE.min := round(spectroBiochrom.LambdaMin);
  LambdaSE.max := round(spectroBiochrom.LambdaMax);
  LambdaSE.position := spectroBiochrom.LambdaCinetique;
  LambdaBisSE.min := round(spectroBiochrom.LambdaMin);
  LambdaBisSE.max := round(spectroBiochrom.LambdaMax);
  deltatSE.min := deltatMinCinetique;
  deltatSE.max := deltatMax;
  nbreSE.min := MinPoints+1;
  nbreSE.max := MaxVecteur;
  nbreSE.Position := spectroBiochrom.nombreCinetique;
  deltatSE.position := spectroBiochrom.deltatCinetique;
  deltatEdit.text := intTostr(deltatSE.position);
  DureeEdit.Text := TimeToStr(EncodeDuree(spectroBiochrom.DureeCinetique));
  LambdaBisSE.position := spectroBiochrom.LambdaCinetiqueBis;
  BlancFait := false;
  labelTemps.caption := '';

  connectBtn.caption := stDeconnect;
  connectBtn.hint := stTouches;
  connectBtn.down := false;
  connectBtn.imageIndex := 11;
  premiereFois := true;

  etatAcq := eaAttenteBlanc;
end;

procedure TCinetiqueForm.BlancBtnClick(Sender: TObject);
var i : integer;
begin
    graphe.NbrePoints := 0;
    PanelDuree.Caption := '';
    AbsLCD.Value := '0.000';
    AbsLCDbis.Value := '0.000';
    LabelTemps.caption := stBlanc;
    screen.cursor := crHourGlass;
    stopEnCours := false;
    BlancFait := false;
    with spectroBiochrom do begin
       DureeEdit.Text := TimeToStr(EncodeDuree(DureeCinetique));
       graphe.MondeX.Maxi := dureeCinetique;
       graphe.MondeY.maxi := AbsMax;
       spectreGraphe.MondeY.maxi := AbsMax;       
       for i := 0 to MaxVecteur do
           graphe.valeurX[i] := deltatCinetique*i;
    end;
    spectroBiochrom.lanceZero(finBlanc);
end;

procedure TCinetiqueForm.StartBtnClick(Sender: TObject);
begin
     if (EtatAcq=eaTerminee) and
        not DejaSauve and
        OKreg(stSauve)
        then RegSaveBtnClick(sender);
     DejaSauve := false;
     graphe.NbrePoints := 0;
     pasSpectreTemps := (spectroBiochrom.nombreCinetique div maxPages) + 1;
     stopEnCours := false;
     graphe.bisActif := lambdaBisCB.checked;
     spectroBiochrom.lambdaCinetique := LambdaSE.position;
     spectroBiochrom.lambdaCinetiqueBis := LambdaBisSE.position;     
     graphe.data.couleur := WaveLengthToColor(spectroBiochrom.lambdaCinetique);
     graphe.dataBis.couleur := WaveLengthToColor(spectroBiochrom.lambdaCinetiqueBis);
     timerSpectre.interval := spectroBiochrom.deltatCinetique*1000;
     statusBar1.SimpleText := stAcqSpectre;
     absLCD.value := '0';
     absLCDbis.value := '0';
     LabelTemps.caption := '';
     debutAcq := now;
     SetBoutons(eaEnCours);
     lanceMesure;
end;

procedure TCinetiqueForm.OscilloPaint(Sender: TObject);

procedure ZoomY;
var j : integer;
    z,max,min : double;
begin with graphe do begin
    max := mondeY.maxi;
    min := mondeY.mini;
    for j := 0 to pred(NbrePoints) do begin
        z := data.valeurY[j];
        if z>max then max := z;
        if z<min then min := z;
    end;
    if lambdaBisCB.checked then
       for j := 0 to pred(NbrePoints) do begin
           z := dataBis.valeurY[j];
           if z>max then max := z;
           if z<min then min := z;
       end;
    if max>spectroBiochrom.absMax then max := spectroBiochrom.absMax;
    if max<0.2 then max := 0.2;
    mondeY.maxi := max;
    mondeY.mini := min;
end end;

var maxGr : double;
begin
     if graphe.NbrePoints>minPoints then begin
         maxGr := graphe.valeurX[pred(graphe.NbrePoints)]+graphe.valeurX[1];
         if maxGr>spectroBiochrom.dureeCinetique
            then graphe.MondeX.Maxi := maxGr
            else graphe.MondeX.Maxi := spectroBiochrom.dureeCinetique;
     end
     else graphe.MondeX.Maxi := spectroBiochrom.dureeCinetique;
     if graphe.NbrePoints>0 then zoomY;
     graphe.limiteFenetre := Oscillo.clientRect;
     graphe.Draw;
     spectrePB.refresh;
end;

procedure TCinetiqueForm.StopBtnClick(Sender: TObject);
begin
     panelDuree.Caption := '';
     labelTemps.caption := '';
     if spectroBiochrom.spectroBusy then begin
        showMessage('Attendre la fin d''acquisition du point courant');
        screen.cursor := crHourGlass;
        stopEnCours := true;
        timerSpectre.enabled := false;
     end
     else setBoutons(eaTerminee);
end;

procedure TCinetiqueForm.TimerSpectreTimer(Sender: TObject);
begin
    if timerSpectre.enabled then lanceMesure;
end;

procedure TCinetiqueForm.TimerHorlogeTimer(Sender: TObject);
begin
    panelDuree.Caption := TimeToStr(now-debutAcq);
end;

procedure TCinetiqueForm.ZoomBtnClick(Sender: TObject);

procedure Zoom;
var j : integer;
    z,max,min : double;
begin with graphe do begin
    max := 0;
    min := 0;
    for j := 0 to pred(NbrePoints) do begin
        z := data.valeurY[j];
        if z>max then max := z;
        if z<min then min := z;
    end;
    if lambdaBisCB.checked then
       for j := 0 to pred(NbrePoints) do begin
           z := dataBis.valeurY[j];
           if z>max then max := z;
           if z<min then min := z;           
       end;
    max := max*1.05;
    if max>spectroBiochrom.absMax then max := spectroBiochrom.absMax;
    if max<0.2 then max := 0.2;
    mondeY.maxi := max;
    mondeY.mini := min;
    mondeX.maxi := valeurX[pred(NbrePoints)]+valeurX[1];
end end;

begin
    if zoomBtn.down and (graphe.NbrePoints>3)
       then zoom
       else begin
          graphe.mondeY.maxi := spectroBiochrom.AbsMax;
          spectreGraphe.mondeY.maxi := spectroBiochrom.AbsMax;
          graphe.mondeY.mini := 0;
          spectreGraphe.mondeY.mini := 0;          
          graphe.mondeX.maxi := spectroBiochrom.dureeCinetique;
       end;
    oscillo.refresh;
end;

procedure TCinetiqueForm.RegSaveBtnClick(Sender: TObject);
begin
   if regressiM.Checked and
      (ConstanteDlg.showModal=mrOk) then begin
        DejaSauve := true;
        FormDDE.EnvoieDonneesCinetique(true);
        constanteDlg.newPageCB.itemIndex := 1;
   end;
   if clipM.Checked then begin
      FormDDE.EnvoieDonneesCinetique(false);
   end;
   if fileM.Checked and
      FormMain.SaveDialog.execute then begin
         formDDE.saveCinetique(FormMain.saveDialog.fileName);
         DejaSauve := true;
   end;
end;

procedure TCinetiqueForm.SetBoutons(etat : TetatCinetique);
var mini,maxi : double;
begin
     EtatAcq := etat;
     StartBtn.enabled := spectroBiochrom.connecte and blancFait and
                         (Etat=eaAttente);
     SpectreBtn.enabled := spectroBiochrom.connecte and blancFait and
                         (Etat in [eaAttente,eaTerminee]);
     SpectrePB.enabled := spectroBiochrom.connecte and blancFait and
                         (Etat in [eaAttente]);
     BlancBtn.enabled := spectroBiochrom.connecte and
                         not (Etat in [eaEnCours,eaSpectreEnCours]);

     timerSpectre.enabled := etat=eaEnCours;
     timerHorloge.Enabled := etat=eaEnCours;

     ResetBtn.enabled := (Etat in [eaTerminee,eaAttente]);
     PrintBtn.enabled := (Etat=eaTerminee) and (graphe.NbrePoints>=minPoints);
     RegSaveBtn.enabled := (Etat=eaTerminee) and (graphe.NbrePoints>=minPoints);

     StopBtn.enabled := Etat=eaEnCours;
     AcqPanel.visible := spectroBiochrom.connecte and (Etat=eaEnCours);

     lambdaSE.enabled := not (EtatAcq in [eaEnCours,eaTerminee]);
     lambdaBisSE.enabled := lambdaSE.enabled;
     lambdaBisCB.enabled := lambdaSE.enabled;
     LabelAbsBis.visible := lambdaSE.enabled and lambdaBisCB.checked;
     AbsLCDbis.visible := (EtatAcq=eaEnCours) and lambdaBisCB.checked;     

     if Etat=eaTerminee then with graphe do begin
        if NbrePoints>=MinPoints
           then GetMinMax(data.valeurY,NbrePoints,mini,maxi)
           else maxi := spectroBiochrom.AbsMax;
        if maxi<1 then maxi := 1;
        graphe.SetMonde(0,0,spectroBiochrom.dureeCinetique,maxi);
        Oscillo.refresh;
     end;

     edit1.setFocus;
end;

procedure TCinetiqueForm.SpectreBtnClick(Sender: TObject);
begin
    SetBoutons(eaSpectreEnCours);
    connectBtn.enabled := false;
    SpectreGraphe.NbrePoints := 0;
    LabelTemps.caption := stAcqSpectre;
    Screen.cursor := crHourGlass;
    spectroBiochrom.lanceSpectre(finSpectreSeul,avail_lambda_abs);
end;

procedure TCinetiqueForm.SpectrePBMouseDown(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
var xi,yi : integer;
begin with spectreGraphe do begin
   curseur := curNone;
   windowXY(spectroBiochrom.lambdaCinetique,0,xi,yi);
   if (abs(xi-x)<4) then begin
       curseur := curLambda;
       spectrePB.hint := 'Rglage de lambda';
   end;
   if lambdaBisCB.Checked then begin
      windowXY(spectroBiochrom.lambdaCinetiqueBis,0,xi,yi);
      if (abs(xi-x)<4) then begin
         curseur := curLambdaBis;
         spectrePB.hint := 'Rglage de lambda 2';
      end;
   end;
   if curseur=curNone
      then spectrePB.cursor := crDefault
      else spectrePB.cursor := crHSplit;
end end;

procedure TCinetiqueForm.SpectrePBPaint(Sender: TObject);

procedure traceLambda(l : integer);
var xi,yi : integer;
begin with spectrePB.canvas do begin
       pen.color := WaveLengthToColor(l);
       pen.width := 3;
       SpectreGraphe.WindowXY(l,0,xi,yi);
       moveTo(xi,0);
       lineTo(xi,spectrePB.height);
end end;

begin with SpectreGraphe do begin
    limiteFenetre := SpectrePB.clientRect;
    MondeY.maxi := graphe.MondeY.maxi;
    mondeY.mini := graphe.MondeY.mini;
    Draw;
    traceLambda(lambdaSE.position);
    if LambdaBisCB.checked then traceLambda(lambdaBisSE.position);
end end;

procedure TCinetiqueForm.SpectroChange;
begin
     StartBtn.enabled := spectroBiochrom.connecte and blancFait and
                         (EtatAcq=eaAttente);
     BlancBtn.enabled := spectroBiochrom.connecte and (EtatAcq<>eaEnCours);
     ResetBtn.enabled := spectroBiochrom.connecte and
                        (EtatAcq in [eaTerminee,eaAttente]);
     AcqPanel.visible := spectroBiochrom.connecte and (EtatAcq=eaEnCours);
	if spectroBioChrom.connecte
    then begin
          connectBtn.caption := stDeconnect;
          connectBtn.hint := stTouches;
          connectBtn.down := false;
          connectBtn.imageIndex := 11;
    end
    else begin
          connectBtn.caption := stConnect;
          connectBtn.hint := stRemote;
          connectBtn.down := true;
          connectBtn.imageIndex := 12;
    end
end;

procedure TCinetiqueForm.ResetBtnClick(Sender: TObject);
begin
     graphe.NbrePoints := 0;
     SpectreGraphe.NbrePoints := 0;
     Oscillo.refresh;
     setBoutons(eaAttente);
     PanelDuree.Caption := '';
     AbsLCD.value := '0.000';
     AbsLCDbis.value := '0.000';
     LabelTemps.Caption := '';
end;

procedure TCinetiqueForm.RegressiMClick(Sender: TObject);
begin
    regSaveBtn.ImageIndex := (sender as TmenuItem).imageIndex;
   (sender as TmenuItem).checked := true;
    regSaveBtn.caption := captionSauve[(sender as TmenuItem).tag];
    regSaveBtnClick(sender);
end;

procedure TCinetiqueForm.ConnectBtnClick(Sender: TObject);
begin
	if spectroBioChrom.connecte
       then spectroBiochrom.release
       else spectroBiochrom.control;
end;

procedure TCinetiqueForm.DeltatSEChanging(Sender: TObject;
  var AllowChange: Boolean);
begin with spectroBiochrom do begin
     DeltatCinetique := DeltatSE.position;
     NombreCinetique := NbreSE.position;
     DureeEdit.Text := TimeToStr(EncodeDuree(DureeCinetique));
     timerSpectre.interval := DeltatCinetique * 1000;
     Oscillo.refresh;
end end;

procedure TCinetiqueForm.DeltatSEChangingEx(Sender: TObject;
  var AllowChange: Boolean; NewValue: Smallint; Direction: TUpDownDirection);
begin with spectroBiochrom do begin
     allowChange := (newValue>=DeltatSE.min) and (Newvalue<=DeltatSE.Max);
     if not allowChange then exit;
     DeltatCinetique := NewValue;
     NombreCinetique := NbreSE.position;
     DureeEdit.Text := TimeToStr(EncodeDuree(DureeCinetique));
     timerSpectre.interval := DeltatCinetique*1000;
     Oscillo.refresh;
end end;

procedure TCinetiqueForm.FormActivate(Sender: TObject);
var ini : TIniFile;
begin
     if premiereFois then begin
        if FileExists(FormMain.NomFichierIni) then begin
        try
        Ini := TIniFile.create(FormMain.NomFichierIni);
        WindowState := TwindowState(Ini.ReadInteger('WindowC','State',ord(wsMaximized)));
        Height := Ini.ReadInteger('WindowC','Height',height);
        Width := Ini.ReadInteger('WindowC','Width',width);
        Top := Ini.ReadInteger('WindowC','Top',top);
        Left := Ini.ReadInteger('WindowC','Left',left);
        regressiM.Checked := Ini.ReadBool('Save','Regressi',false);
    if regressiM.Checked then begin
       regSaveBtn.ImageIndex := regressiM.imageIndex;
       regSaveBtn.caption := 'Regressi';
    end;
    clipM.Checked := Ini.ReadBool('Save','Clip',true);
    if clipM.Checked then begin
       regSaveBtn.ImageIndex := clipM.imageIndex;
       regSaveBtn.caption := 'Copier';
    end;
    fileM.Checked := Ini.ReadBool('Save','File',false);
    if fileM.Checked then begin
       regSaveBtn.ImageIndex := fileM.imageIndex;
       regSaveBtn.caption := 'Sauver';
    end;
        Ini.free;
        except
        end;
        end;
        gripSplitter1.snapped := true;
     end; // premiereFois
     premiereFois := false;
     spectroBiochrom.spectreBinaire := true;
     setBoutons(etatAcq);
end;

procedure TCinetiqueForm.FormClose(Sender: TObject;var Action: TCloseAction);

procedure WriteFormPlacement;
var
  ini : TmemIniFile;
begin
  try
  Ini := TmemIniFile.create(FormMain.NomFichierIni);
  Ini.WriteInteger('WindowC','State',ord(WindowState));
  Ini.WriteInteger('WindowC','Height',height);
  Ini.WriteInteger('WindowC','Width',width);
  Ini.WriteInteger('WindowC','Top',top);
  Ini.WriteInteger('WindowC','Left',left);
  Ini.WriteBool('Save','Regressi',regressiM.Checked);
  Ini.WriteBool('Save','Clip',clipM.Checked);
  Ini.WriteBool('Save','File',fileM.Checked);
  ini.UpdateFile;
  Ini.free;
  except
  end;
end;

begin
    if stopBtn.Enabled then stopBtnClick(sender);
    timerSpectre.enabled := false;
    timerHorloge.enabled := false;
    writeFormPlacement;
    FormMain.setMode(mNone);
end;

procedure TCinetiqueForm.FormCloseQuery(Sender: TObject; var CanClose: Boolean);
begin
    if (EtatAcq=eaTerminee) and
        not DejaSauve and
        (graphe.NbrePoints>=minPoints) and
       OKreg(stSauve)
        then RegSaveBtnClick(sender);
    if stopBtn.enabled
       then if OKreg(stArret)
          then canClose := true
          else canClose := false
       else canClose := true
end;

procedure TCinetiqueForm.ExitBtnClick(Sender: TObject);
begin
     close
end;

procedure TCinetiqueForm.FormDestroy(Sender: TObject);
begin
    Graphe.free;
    SpectreGraphe.free;
end;

procedure TCinetiqueForm.FormKeyPress(Sender: TObject; var Key: Char);
begin
     if (key=' ') then
        if StartBtn.enabled
           then begin
              startBtnClick(sender);
              key := #0;
           end
           else if BlancBtn.enabled then begin
              blancBtnClick(sender);
              key := #0;
           end;
end;

procedure TCinetiqueForm.LambdaBisCBClick(Sender: TObject);
begin
	lambdaBisSE.visible := LambdaBisCB.Checked;
	lambdaBisEdit.visible := LambdaBisCB.Checked;
    edit1.setFocus;
end;

procedure TCinetiqueForm.LambdaSEChangingEx(Sender: TObject;
  var AllowChange: Boolean; NewValue: Smallint; Direction: TUpDownDirection);
begin with spectroBiochrom do begin
     allowChange := (newValue>LambdaMin) and (Newvalue<lambdaMax);
     if not allowChange then exit;
     if (sender as TupDown).tag=0
         then lambdaCinetique := NewValue
         else lambdaCinetiqueBis := NewValue;
     if not gripSplitter1.snapped then spectrePB.refresh;
end end;

procedure TCinetiqueForm.NbreEditChange(Sender: TObject);
begin with spectroBiochrom do begin
     NombreCinetique := NbreSE.position;
     DeltatCinetique := DeltatSE.position;
     DureeEdit.Text := TimeToStr(EncodeDuree(DureeCinetique));
     Oscillo.refresh;
end end;

procedure TCinetiqueForm.NbreEditKeyPress(Sender: TObject; var Key: Char);
var AllowChange: Boolean;
begin
    if key=char(vk_return)
       then NbreSEChanging(sender,AllowChange)
       else if not isValidChar(key) then key := #0
end;

procedure TCinetiqueForm.NbreSEChanging(Sender: TObject;
  var AllowChange: Boolean);
begin with spectroBiochrom do begin
     NombreCinetique := NbreSE.position;
     DeltatCinetique := DeltatSE.position;
     DureeEdit.Text := TimeToStr(EncodeDuree(DureeCinetique));
     Oscillo.refresh;
end end;

procedure TCinetiqueForm.NbreSEChangingEx(Sender: TObject;
  var AllowChange: Boolean; NewValue: Smallint; Direction: TUpDownDirection);
begin with spectroBiochrom do begin
     allowChange := (newValue>=NbreSE.min) and (Newvalue<=NbreSE.Max);
     if not allowChange then exit;
     NombreCinetique := NewValue;
     DeltatCinetique := DeltatSE.position;
     DureeEdit.Text := TimeToStr(EncodeDuree(DureeCinetique));
     pasSpectreTemps := (spectroBiochrom.nombreCinetique div maxPages) + 1;
     Oscillo.refresh;
end end;

procedure TCinetiqueForm.PrintBtnClick(Sender: TObject);
begin
    Graphe.imprime
end;

procedure TCinetiqueForm.FinSpectre;
begin
     graphe.valeurX[graphe.NbrePoints] := DureeSec(instantLecture);
     AbsLCD.value := floatToStrF(graphe.data.valeurY[graphe.NbrePoints],ffFixed,4,3);
     labelTemps.Caption := stAcquis+TimeToStr(instantLecture);
     graphe.traceUnPoint(graphe.NbrePoints,graphe.data);
     if graphe.NbrePoints<MaxPages then
        spectreTemps[graphe.NbrePoints div pasSpectreTemps] :=  spectreGraphe.data.valeurY;
     if lambdaBisCB.checked then begin
        AbsLCDbis.value := floatToStrF(graphe.dataBis.valeurY[graphe.NbrePoints],ffFixed,4,3);
        graphe.traceUnPoint(graphe.NbrePoints,graphe.dataBis);
     end;
     inc(graphe.NbrePoints);
     if (graphe.NbrePoints>spectroBiochrom.NombreCinetique) or
        stopEnCours
        then SetBoutons(eaTerminee);
     if not gripSplitter1.snapped then spectrePB.refresh;        
     connectBtn.enabled := true;
     screen.cursor := crDefault;
     stopEnCours := false;     
     if relancerSpectre then begin
         lanceMesure;
       // ordre arrive avant la fin de l'acquisition du spectre
       // on allonge la dure
         timerSpectre.interval := timerSpectre.interval + 1000;
      // trop rapide : on ajoute 1 s 
     end;
end;

procedure TCinetiqueForm.FinSpectreSeul;
begin
     gripSplitter1.snapped := false;
     labelTemps.caption := '';
     spectrePB.refresh;
     connectBtn.enabled := true;
     screen.cursor := crDefault;
     SetBoutons(eaAttente);
end;

procedure TCinetiqueForm.FinBlanc;
begin
   BlancFait := true;
   LabelTemps.caption := '';
   screen.cursor := crDefault;
   panelBlanc.visible := false;
   setBoutons(eaAttente);
end;

procedure TCinetiqueForm.Avail_Lambda_Abs(Lambda : integer;abs : double);
begin
     try
          with SpectreGraphe do begin
               valeurX[NbrePoints] := lambda;
               data.valeurY[NbrePoints] := abs;
               inc(NbrePoints);
          end;
          if SpectreGraphe.nbrePoints=0 then
             labelTemps.caption := stLectureSpectre;
          if lambda=spectroBiochrom.lambdaCinetique then
             graphe.data.valeurY[graphe.NbrePoints] := abs;
          if lambda=spectroBiochrom.lambdaCinetiqueBis then
             graphe.dataBis.valeurY[graphe.NbrePoints] := abs;
     except
     end;
end;

procedure TCinetiqueForm.lanceMesure;
begin
    connectBtn.enabled := false;
    relancerSpectre := spectroBiochrom.SpectroBusy;
    if not relancerSpectre then begin
       instantLecture := now-debutAcq;
       SpectreGraphe.NbrePoints := 0;
       spectroBiochrom.lanceSpectre(finSpectre,avail_lambda_abs);
    end;
end;

{
procedure TCinetiqueForm.SauvePages;
var fichier : TextFile;
    nomFichier : string;

Procedure EcritPage(page : integer);
var i : integer;
begin
    writeln(fichier,symbReg,'1 PAGE COMMENT');
    writeln(fichier,'');
    writeln(fichier,symbReg2,IntToStr(spectreGraphe.NbrePoints)+' VALEUR VAR');
    for i := 0 to pred(spectreGraphe.NbrePoints) do begin
        write(fichier,spectreGraphe.valeurX[i]);
        writeln(fichier,spectreTemps[page,i]);
    end; // for j
    writeln(fichier,symbReg2,'1 VALEUR CONST');
    writeln(fichier,graphe.valeurX[page]);
end; // ecritPage

Procedure ecritEnTete;
begin
   writeln(fichier,'EVARISTE REGRESSI WINDOWS 1.0');
   writeln(fichier,symbReg,'2 NOM VAR');
   writeln(fichier,lambdaR);
   writeln(fichier,'A');
   writeln(fichier,symbReg,'2 GENRE VAR');
   writeln(fichier,0); // variable
   writeln(fichier,0);
   writeln(fichier,symbReg,'2 UNITE VAR');
   writeln(fichier,'nm');
   writeln(fichier);
   writeln(fichier,symbReg,'2 SIGNIF VAR');
   writeln(fichier,stLambda);
   writeln(fichier,stAbs);
   writeln(fichier,symbReg,'1 NOM CONST');
   writeln(fichier,'t');
   writeln(fichier,symbReg,'1 UNITE CONST');
   writeln(fichier,'s');
   writeln(fichier,symbReg,'1 SIGNIF CONST');
   writeln(fichier,'temps');
   writeln(fichier,symbReg,'2 ACQUISITION');
   writeln(fichier,'EXTERNE');
   writeln(fichier,application.exeName);
end; // ecritEnTete

var i : integer;
begin
   FormMain.SaveDialog.filter := 'Regressi|*.rw3';
   if FormMain.SaveDialog.execute then begin
      Screen.cursor := crHourGlass;
      NomFichier := FormMain.saveDialog.fileName;
      NomFichier := changeFileExt(NomFichier,'.rw3');
      AssignFile(fichier,NomFichier);
      Rewrite(fichier);
      try
      ecritEnTete;
      for i := 0 to pred(graphe.nbrePoints) do ecritPage(i);
      CloseFile(fichier);
      except
         CloseFile(fichier);
         AfficheErreur(erWriteFile);
      end;
      Screen.cursor := crDefault;
   end;
   FormMain.SaveDialog.filter := 'Tableur texte|*.txt|Tableur CSV|*.csv';
end;
}

procedure TCinetiqueForm.SpectrePBMouseUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
var xr,yr : double;
begin
   if curseur<>curNone then with spectreGraphe do begin
      MondeXY(X,Y,xr,yr);
      case curseur of
           curLambda : lambdaSE.position := round(xr);
           curLambdaBis : lambdaBisSE.position := round(xr);
      end;
      curseur := curNone;
      spectrePB.cursor := crDefault;
      spectrePB.hint := '';
   end;
end;

procedure TCinetiqueForm.SpectrePBMouseMove(Sender: TObject; Shift: TShiftState;
  X, Y: Integer);
var xi,yi : integer;
    xr,yr : double;
begin with spectreGraphe do begin
   if curseur=curNone
       then begin
            spectrePB.hint := '';
            windowXY(spectroBiochrom.lambdaCinetique,0,xi,yi);
            if (abs(xi-x)<4) then begin
               spectrePB.hint := 'Rglage de lambda';
               spectrePB.cursor := crHsplit;
               exit;
            end;
            windowXY(spectroBiochrom.lambdaCinetiqueBis,0,xi,yi);
            if (abs(xi-x)<4) then begin
               spectrePB.hint := 'Rglage de lambda 2';
               spectrePB.cursor := crHsplit;
               exit;
            end;
            spectrePB.hint := '';
            spectrePB.cursor := crDefault;
        end
        else if ssLeft in Shift then begin
              MondeXY(X,Y,xr,yr);
              xi := round(xr);
              case curseur of
                  curLambda : LambdaSE.position := xi;
                  curLambdaBis : LambdaBisSE.position := xi;
              end;
        end;
end end;

end.

