unit spectrodde;

interface

uses
  SysUtils, Windows, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, StdCtrls, DdeMan, ExtCtrls, registry, clipbrd, oomisc,
  spectromain, jmmUtil, spectrocst, graphker;

type
  TFormDDE = class(TForm)
    ClientDDE: TDdeClientConv;
    ClientItem: TDdeClientItem;
    ServeurDDE: TDdeServerConv;
    procedure FormCreate(Sender: TObject);
    procedure ExecuteMacro(Sender: TObject; Msg: TStrings);
  private
    donnees : TstringList;
    csv : boolean;
    fichier : textFile;
    separeValue : char;
    procedure AjouteConst;
    Procedure sautDeLigne(ligne : shortString);
    Procedure OuvreFichier(nomFichier : string);
  public
    procedure Execute(Ordre : String);
    procedure Envoie(dde : boolean);
    procedure EnvoieDonneesSpectre(dde : boolean);
    procedure EnvoieDonneesCinetique(dde : boolean);
    procedure EnvoieDonneesBeer(dde : boolean);
    procedure SaveCinetique(nomFichier : string);
    procedure SaveSpectre(nomFichier : string);
    procedure SaveBeer(nomFichier : string);    
  end;

var
  FormDDE: TFormDDE;

implementation

uses SpectroBeer, SpectroTrace, Spectrocinet;

{$R *.DFM}

procedure TFormDDE.AjouteConst;
var avecConst : boolean;
    valeurConst : double;
begin with constanteDlg do begin
      AvecConst := NomConstEdit.text<>'';
      if avecConst then begin
         try
            ValeurConst := StrToFloatWin(ValeurConstEdit.text);
         except
            AvecConst := false;
         end;
     end;
     if avecConst then begin
            Donnees.Add('');
            Donnees.Add(NomConstEdit.text);
            Donnees.Add(UniteConstEdit.text);
            Donnees.Add(ValeurConstEDit.text);
     end;
end end;

   Procedure TFormDDE.sautDeLigne(ligne : shortString);
   begin
       write(fichier,ligne);
       if CSV then write(Fichier,crLF) else writeln(fichier)
   end;

procedure TFormDDE.Execute(Ordre : String);

Procedure lanceRegressi;
var hSemaphore : integer;
    CharVal: array[0..1024] of Char;
begin
   StrPCopy(CharVal, 'Regressi');
   hSemaphore := CreateSemaphore(nil,0,1,CharVal);
   if (hSemaphore<>0) and
      (GetLastError = Error_Already_Exists) then exit;
   StrPCopy(CharVal, ClientDde.ServiceApplication);
   if WinExec(CharVal, SW_SHOWDEFAULT) >= 32 then sleep(2000);
end;

Procedure Lance;
var Buf : PChar;
begin
       Buf := StrAlloc(Succ(Length(Ordre)));
       if not ClientDDE.ExecuteMacro(strPcopy(Buf,Ordre), false) then
            ShowMessage(Ordre+' non excut');
       StrDispose(Buf);
       ClientDDE.closeLink;
end;

begin
     LanceRegressi;
     ClientDDE.SetLink('REGRESSI','ServeurDDE');
     ClientItem.DDEItem := 'ServeurItem';
     if ClientDDE.OpenLink
       then lance
       else begin
           sleep(1000);
       // OpenLik false efface
           ClientDDE.SetLink('Regressi','ServeurDDE');
           ClientItem.DDEItem := 'ServeurItem';
           if ClientDDE.OpenLink
              then lance
              else ShowMessage('Impossible de lancer Regressi');
       end;
end;

procedure TFormDDE.EnvoieDonneesSpectre(dde : boolean);

Procedure AjouteOptionsGr;
begin with TraceSpectre.graphe do begin
     donnees.Add(symbReg2+'1 NOMX');
     donnees.Add(mondeX.nom);
     donnees.Add(symbReg2+'1 NOMY');
     donnees.Add(mondeY.nom);
     donnees.Add(symbReg2+'1 DIMPOINT');
     donnees.Add(IntToStr(dimPoint));
     donnees.Add(symbReg2+'1 GRILLE');
     donnees.Add(IntToStr(ord(Quadrillage)));
     donnees.Add(symbReg2+'1 COULEUR');
     donnees.Add(IntToStr(data.couleur));
     donnees.Add(symbReg2+'1 MOTIF');
     donnees.Add('0'); // croix
     donnees.Add(symbReg2+'1 LIGNE');
     case trace of
          trLigne : donnees.Add('2');
          trPoint : donnees.Add('1');
          trLignePoint : donnees.Add('3');
          trSpectre : donnees.Add('2');
     end;
     donnees.Add(symbReg2+'1 ZEROX');
     donnees.Add('0');
end end;

var i : integer;
    LigneCourante : shortString;
begin with traceSpectre.graphe do begin
     Donnees := TstringList.Create;
     if dde then Donnees.Add(Application.ExeName);
     Donnees.Add('Spectre '+DateTimeToStr(date+time));
     Donnees.Add(constanteDlg.editComm.text);
     if dde
        then LigneCourante := LambdaR+crTab+'A'
        else LigneCourante := 'Lambda'+crTab+'A';
     Donnees.Add(LigneCourante);
     LigneCourante := 'nm'+crTab+'';
     Donnees.Add(LigneCourante);
     LigneCourante := stLambda+crTab+data.Titre;
     Donnees.Add(LigneCourante);
     for i := 0 to pred(NbrePoints) do begin
         if dde
            then LigneCourante := FloatToStrPoint(valeurX[i])+crTab+
                 FloatToStrPoint(data.valeurY[i])
            else LigneCourante := FloatToStrWin(valeurX[i])+crTab+
                FloatToStrWin(data.valeurY[i]);
         Donnees.Add(LigneCourante);
     end;
     if dde then begin
        AjouteConst;
        AjouteOptionsGr;
     end;
     Envoie(dde);
end end;

procedure TFormDDE.EnvoieDonneesCinetique(dde : boolean);

Procedure AjouteOptionsGr;
begin with CinetiqueForm.graphe do begin
     donnees.Add(symbReg2+'1 NOMX');
     donnees.Add(mondeX.nom);
     donnees.Add(symbReg2+'1 NOMY');
     donnees.Add(mondeY.nom);
     donnees.Add(symbReg2+'1 DIMPOINT');
     donnees.Add(IntToStr(dimPoint));
     donnees.Add(symbReg2+'1 GRILLE');
     donnees.Add(IntToStr(ord(Quadrillage)));
     donnees.Add(symbReg2+'1 COULEUR');
     donnees.Add(IntToStr(data.couleur));
     donnees.Add(symbReg2+'1 MOTIF');
     donnees.Add('5'); // cercle plein
     donnees.Add(symbReg2+'1 LIGNE');
     case trace of
          trLigne : donnees.Add('2');
          trPoint : donnees.Add('1');
          trLignePoint : donnees.Add('3');
     end;
end end;

Procedure AjouteOptionsGrBis;
begin with CinetiqueForm.graphe do begin
     donnees.Add(symbReg2+'2 NOMX');
     donnees.Add(mondeX.nom);
     donnees.Add(mondeX.nom);
     donnees.Add(symbReg2+'2 NOMY');
     donnees.Add(mondeY.nom);
     donnees.Add(mondeY.nom+'2');
     donnees.Add(symbReg2+'1 DIMPOINT');
     donnees.Add(IntToStr(dimPoint));
     donnees.Add(symbReg2+'1 GRILLE');
     donnees.Add(IntToStr(ord(Quadrillage)));
     donnees.Add(symbReg2+'2 COULEUR');
     donnees.Add(IntToStr(data.couleur));
     donnees.Add(IntToStr(dataBis.couleur));     
     donnees.Add(symbReg2+'2 MOTIF');
     donnees.Add('5'); // cercle plein
     donnees.Add('5'); // cercle plein
     donnees.Add(symbReg2+'2 LIGNE');
     case trace of
          trLigne : begin
             donnees.Add('2');donnees.Add('2');
          end;
          trPoint : begin
             donnees.Add('1');donnees.Add('1');
          end;
          trLignePoint : begin
             donnees.Add('3');donnees.Add('3');
          end;
     end;
end end;

var i : integer;
    ligne : shortString;
begin with CinetiqueForm,graphe do begin
     Donnees := TstringList.create;
     if dde then Donnees.Add(Application.ExeName);
     Donnees.Add('Cintique  '+DateTimeToStr(date+time));
     Donnees.Add(ConstanteDlg.EditComm.text);
     ligne := MondeX.nom+crTab+MondeY.nom;
     if lambdaBisCB.checked then ligne := ligne +crTab+MondeY.nom+'2';
     Donnees.Add(ligne);
     ligne := MondeX.unite+crTab+MondeY.unite;
     if lambdaBisCB.checked then ligne := ligne + crTab+MondeY.unite;
     Donnees.Add(ligne);
     ligne := MondeX.signif+crTab+MondeY.signif;
     if lambdaBisCB.checked then ligne := ligne + crTab+MondeY.signif;
     Donnees.Add(ligne);
     for i := 0 to pred(NbrePoints) do begin
         if dde
            then ligne := FloatToStrPoint(valeurX[i])+crTab+
                  FloatToStrPoint(data.valeurY[i])
            else ligne := FloatToStrWin(valeurX[i])+crTab+
                  FloatToStrWin(data.valeurY[i]);
         if lambdaBisCB.checked then if dde then
         ligne := ligne + crTab+
            FloatToStrPoint(dataBis.valeurY[i])
         else ligne := ligne + crTab+
            FloatToStrWin(dataBis.valeurY[i]);
         Donnees.Add(ligne);
     end;
     if dde then AjouteConst;
     if dde then if lambdaBisCB.checked
        then AjouteOptionsGrBis
        else AjouteOptionsGr;
     Envoie(dde);
end end;

procedure TFormDDE.SaveSpectre(nomFichier : string);
var i : integer;
    ligne : shortString;
begin with traceSpectre.graphe do begin
   ouvreFichier(NomFichier);
   sautDeLigne(constanteDlg.editComm.text);
   ligne := 'Lambda'+separeValue+'A';
   sautDeLigne(ligne);
   ligne := 'nm'+separeValue;
   sautDeLigne(ligne);
   ligne := stLambda+separeValue+data.Titre;
   sautDeLigne(ligne);
   for i := 0 to pred(NbrePoints) do begin
       ligne := FloatToStrWin(valeurX[i])+
                    separeValue+
                    FloatToStrWin(data.valeurY[i]);
       sautDeLigne(ligne);
   end;
   CloseFile(fichier);
end end;

procedure TFormDDE.SaveBeer(nomFichier : string);
var i : integer;
    ligne : shortString;
begin with BeerForm.graphe do begin
   ouvreFichier(NomFichier);
   sautDeLigne('Loi de Beer-Lambert '+DateTimeToStr(date+time));
   ligne := MondeX.nom+separeValue+mondeY.nom;
   sautDeLigne(ligne);
   ligne := MondeX.unite+separeValue+mondeY.unite;
   sautDeLigne(ligne);
   ligne := MondeX.signif+separeValue+mondeY.signif;
   sautDeLigne(ligne);
   for i := 0 to pred(NbrePoints) do begin
       ligne := FloatToStrWin(valeurX[i])+
                    separeValue+
                    FloatToStrWin(data.valeurY[i]);
       sautDeLigne(ligne);
   end;
   CloseFile(fichier);
end end;

procedure TFormDDE.SaveCinetique(nomFichier : string);
var i : integer;
    ligne : shortString;
begin with CinetiqueForm,graphe do begin
   ouvreFichier(NomFichier);
   sautDeLigne(ConstanteDlg.EditComm.text);
   ligne := MondeX.nom+separeValue+MondeY.nom;
   if lambdaBisCB.checked then ligne := ligne +separeValue+MondeY.nom+'2';
   sautDeLigne(ligne);
   ligne := MondeX.unite+separeValue+MondeY.unite;
   if lambdaBisCB.checked then ligne := ligne + separeValue+MondeY.unite;
   sautDeLigne(ligne);
   ligne := MondeX.signif+separeValue+MondeY.signif;
   if lambdaBisCB.checked then ligne := ligne + separeValue+MondeY.signif;
   sautDeLigne(ligne);
   for i := 0 to pred(NbrePoints) do begin
         ligne := FloatToStrWin(valeurX[i])+
                  separeValue+
                  FloatToStrWin(data.valeurY[i]);
         if lambdaBisCB.checked then
         ligne := ligne + separeValue+
            FloatToStrWin(dataBis.valeurY[i]);
         sautDeLigne(ligne);
   end;
   CloseFile(fichier);
end end;

procedure TFormDDE.EnvoieDonneesBeer(dde : boolean);

Procedure AjouteOptionsGr;
begin with BeerForm.graphe do begin
     donnees.Add(symbReg2+'1 NOMX');
     donnees.Add(mondeX.nom);
     donnees.Add(symbReg2+'1 NOMY');
     donnees.Add(mondeY.nom);
     donnees.Add(symbReg2+'1 DIMPOINT');
     donnees.Add(IntToStr(dimPoint));
     donnees.Add(symbReg2+'1 GRILLE');
     donnees.Add(IntToStr(ord(Quadrillage)));
     donnees.Add(symbReg2+'1 COULEUR');
     donnees.Add(IntToStr(data.couleur));
     donnees.Add(symbReg2+'1 MOTIF');
     donnees.Add('5'); // cercle Plein
     donnees.Add(symbReg2+'1 LIGNE');
     case trace of
          trLigne : donnees.Add('2');
          trPoint : donnees.Add('1');
          trLignePoint : donnees.Add('3');
     end;
end end;

var i : integer;
begin with BeerForm.graphe do begin
     Donnees := TstringList.create;
     if dde then Donnees.Add(Application.ExeName);
     Donnees.Add('Loi de Beer-Lambert '+DateTimeToStr(date+time));
     Donnees.Add(ConstanteDlg.EditComm.text);
     Donnees.Add(MondeX.nom+crTab+MondeY.nom);
     Donnees.Add(MondeX.unite+crTab+MondeY.unite);
     for i := 0 to pred(NbrePoints) do begin
         if dde then Donnees.Add(
           FloatToStrPoint(valeurX[i])+crTab+
           FloatToStrPoint(data.valeurY[i]))
           else Donnees.Add(
           FloatToStrWin(valeurX[i])+crTab+
           FloatToStrWin(data.valeurY[i]));
     end;
     if dde then begin
        AjouteConst;
        AjouteOptionsGr;
     end;
     Envoie(dde);
end end;

procedure TFormDDE.ExecuteMacro(Sender: TObject; Msg: TStrings);
begin
    if (Msg.Count = 1) then case FormMain.AcquisitionEnCours of
            mSpectre : TraceSpectre.setFocus;
            mCinetique : CinetiqueForm.setFocus;
            mNone : FormMain.setFocus;
    end;
end;

procedure TFormDDE.FormCreate(Sender: TObject);
var Ini : TRegIniFile;
begin
    Ini := TRegIniFile.create('Software');
    ClientDDE.ServiceApplication := Ini.ReadString('Regressi','Path','');
    Ini.Free;
    Ini := TRegIniFile.create('Software\Regressi');
    ClientDDE.ServiceApplication := Ini.ReadString('Regressi','Path',ClientDDE.ServiceApplication);
    Ini.Free;
    if ClientDDE.ServiceApplication='' then
       ClientDDE.ServiceApplication := 'regressi.exe';
end;

procedure TFormDDE.Envoie(dde : boolean);
begin
     ClipBoard.asText := donnees.text;
     if dde then begin
        if ConstanteDlg.NewPageCB.itemIndex=1
           then Execute('CLIP|ADD()')
           else Execute('CLIP|LOAD()');
        constanteDlg.newPageCB.itemIndex := 1;
     end;
     donnees.free;
end;

procedure TFormDDE.OuvreFichier(nomFichier : string);
var extension : shortString;
begin
     extension := AnsiUpperCase(ExtractFileExt(NomFichier));
     if extension = '' then begin
        if FormMain.SaveDialog.filterIndex=1 then extension := '.TXT';
        if FormMain.SaveDialog.filterIndex=2 then extension := '.CSV';
        NomFichier := NomFichier+extension;
     end;
     CSV := extension='.CSV';
     if CSV
        then if decimalSeparator='.'
            then separeValue := ','
            else separeValue := ';'
        else separeValue := crTab;
     AssignFile(fichier, NomFichier);
     Rewrite(fichier);
end;

end.
